function [charaction, numaction, WP, W]= Choose_action_MoBLeS ( Policy, state, Q2, QX, QY, Thr) 
% New function for choose action in subspace
% this is the normal version


global  Q Q_B Number_S_Action Number_S2NS_Action Trns_S2NS_Action Reward_S_Action Ret NRet BestR alpha gama delta E Q_BD Q_X Q_Y
global MaxStep num_episode num_runs NumAction Length LL P_C landa
global Q_LCRL Q_XL Q_YL
global Array_CI_p M_Array m_Array D_Array ChooseSpace
global Q_UCRL Q_XU Q_YU
global Number_X_Action Number_X2NX_Action Trns_X2NX_Action Number_Y_Action Number_Y2NY_Action Trns_Y2NY_Action Reward_X_Action Reward_Y_Action
global Numsubspaces 
global CountWX CountWY

% Policy = struct('type','Boltzman','parameter',epsilon); 
% Policy.parameter = 1 / sum(Number_S_Action(state.x, state.y, :)) ;
% if sum(Number_S_Action(state.x, state.y, :)) ==0
%     Policy.parameter = 1;
% end

Policy.parameter = 0.1;

% Policy.parameter = 20/(2*sum(Number_S_Action(state.x, state.y, :))); % for Boltzman
if strcmp(Policy.type,'Boltzman')==1 && Policy.parameter < 1
    Policy.parameter = 1;
end
flag=0;

% assign probability
P = zeros(Numsubspaces,NumAction); % 1 for x ---- 2 for y ---- 3 for joint
rowa = find(Number_S_Action(state.x, state.y, :)==0);

if strcmp(Policy.type,'e-greedy')==1
    P(:, :) = Policy.parameter/NumAction ;
    [~, ax]=max(QX(state.x, :));
    [~, ay]=max(QY(state.y, :));
    [~, aj]=max(Q2(state.x, state.y, :));
    P(1, ax)=P(1, ax)+ 1-Policy.parameter ;
    P(2, ay)=P(2, ay)+ 1-Policy.parameter ;
    P(3, aj)=P(3, aj)+ 1-Policy.parameter ;

elseif strcmp(Policy.type,'Boltzman')==1
    for i=1 : NumAction
        P(1, :)= reshape(exp(QX(state.x, :)./Policy.parameter)./sum(exp(QX(state.x, :)./Policy.parameter)),1, NumAction);
        P(2, :)= reshape(exp(QY(state.y, :)./Policy.parameter)./sum(exp(QY(state.y, :)./Policy.parameter)),1, NumAction);
        P(3, :)= reshape(exp(Q2(state.x, state.y, :)./Policy.parameter)./sum(exp(Q2(state.x, state.y, :)./Policy.parameter)),1, NumAction);
    end
end


% assign weight
W = zeros(Numsubspaces,NumAction); % 1 for x ---- 2 for y ---- 3 for joint
Dif_X= abs(Q_XU - Q_XL);
Dif_Y= abs(Q_YU - Q_YL);
Dif_J= abs(Q_UCRL - Q_LCRL);
Intsx =0;
Intsy =0;
intersecX=0;
intersecY=0;
for i=1 : NumAction
    if ~(Q_XU(state.x, i)< Q_LCRL(state.x, state.y, i) || Q_XL(state.x, i)> Q_UCRL(state.x, state.y, i))
        if  Q_XL(state.x, i)<= Q_LCRL(state.x, state.y, i)
            if Q_XU(state.x, i)<= Q_UCRL(state.x, state.y, i)
                intersecX = Q_XU(state.x, i)- Q_LCRL(state.x, state.y, i);
            else
                intersecX = Q_UCRL(state.x, state.y, i) - Q_LCRL(state.x, state.y, i);
            end
        else
            if Q_XU(state.x, i)<= Q_UCRL(state.x, state.y, i)
                intersecX = Q_XU(state.x, i)- Q_XL(state.x, i);
            else
                intersecX = Q_UCRL(state.x, state.y, i) - Q_XL(state.x, i);
            end
        end
        Intsx = intersecX/Dif_X(state.x, i);
        if Dif_X(state.x, i)<= 0.05
            Intsx = 1;
        end
    end
    if ~(Q_YU(state.y, i)< Q_LCRL(state.x, state.y, i) || Q_YL(state.y, i)> Q_UCRL(state.x, state.y, i))
        if  Q_YL(state.y, i)<= Q_LCRL(state.x, state.y, i)
            if Q_YU(state.y, i)<= Q_UCRL(state.x, state.y, i)
                intersecY = Q_YU(state.y, i)- Q_LCRL(state.x, state.y, i);
            else
                intersecY = Q_UCRL(state.x, state.y, i) - Q_LCRL(state.x, state.y, i);
            end
        else
            if Q_YU(state.y, i)<= Q_UCRL(state.x, state.y, i)
                intersecY = Q_YU(state.y, i)- Q_YL(state.y, i);
            else
                intersecY = Q_UCRL(state.x, state.y, i) - Q_YL(state.y, i);
            end
        end
        Intsy = intersecY/Dif_Y(state.y, i);
        if Dif_Y(state.y, i) <= 0.05
            Intsy = 1;
        end
    end
    
     
     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     
     x1= ( (Dif_J(state.x, state.y, i)) / Dif_X(state.x, i) ) ;
     y1 = ( (Dif_J(state.x, state.y, i)) / Dif_Y(state.y, i) ) ;
     
     x2=abs(Q2(state.x, state.y, i)- QX(state.x, i))/intersecX ;
     y2=abs(Q2(state.x, state.y, i)- QY(state.y, i))/intersecY ;
     
  
     
     if 2*x2>1
         x2=1/2;
     end
     if 2*y2>1
         y2=1/2;
     end
     x6 = -erfinv(2*x2 - 1);
     y6 = -erfinv(2*y2 - 1);
     

    x7=x6;
    y7=y6;
     if x6>=1
         x7=1;
     elseif x6<1
         x7=0;
     end
     if y6>=1
         y7=1;
     elseif y6<1
         y7=0;
     end
     

      W(1, i)= x1 * x7 ;
      W(2, i)= y1 * y7 ;

     if (Dif_J(state.x, state.y, i))/ Dif_X(state.x, i) <0.9
         W(1, i) =0;
     end
     if (Dif_J(state.x, state.y, i))/Dif_Y(state.y, i) < 0.9
         W(2, i)=0;
     end
     
     W(3, i)=1;
     
  

     
     
    W(:,i)= W(:,i)./ sum(W(:,i), 1);
    
     maxW=-1;

     if W(1, i)>maxW
         maxW = W(1, i);
         indW=1;
     end
      if W(2, i)>maxW
         maxW = W(2, i);
         indW=2;
      end
      if W(3, i)>maxW
         maxW = W(3, i);
         indW=3;
     end
     if indW==1
         if CountWX <= Thr
             W(1, i)=1;
             W(2, i)=0;
             W(3, i)=0;
         else
             W(1, i)=0;
             if CountWY <= Thr && W(2, i)> W(3, i)
                     W(2, i)= 1;
                     W(3, i)=0;
             else
                 W(2, i)=0;
                 W(3, i)=1;
             end
         end
     elseif indW==2
         if CountWY <= Thr
             W(1, i)=0;
             W(2, i)=1;
             W(3, i)=0;
         else
             W(2, i)=0;
             if CountWX <= Thr && W(1, i)> W(3, i)
                     W(1, i)= 1;
                     W(3, i)=0;
             else
                 W(1, i)=0;
                 W(3, i)=1;
             end
         end
     elseif indW==3
         W(1, i)=0;
         W(2, i)=0;
         W(3, i)=1;
     end
    
end


% ****************************

WP= W .* P;
Prob = sum (WP(:,:), 1);
Prob = Prob./sum(Prob);


% -- find best action acccording probability
if flag==0 || 1
    rnd=rand(1);
    for i=1 : NumAction
        if rnd<=sum(Prob(1:i))
            act=i;
            flag=1;
            %fprintf('%d\n', sum(Prob(1:i)));
            break;
        end
    end
% -- find just max probability
%     [~, act]=max(Prob);
end




 if act==1
    action='u';
elseif act==2
    action='r';
elseif act==3
    action='d';
elseif act==4
    action='l';
else
    action='n';
end
charaction=action;
numaction=act;
end




