function [charaction, numaction, WP, W]= Choose_action_MoBLeS3D( Policy, state, Thr) 
% New function for choose action in subspace
% this is the normal version


global  Q Q_B Number_S_Action Number_S2NS_Action Trns_S2NS_Action Reward_S_Action Ret NRet BestR alpha gama delta E Q_BD Q_X Q_Y
global MaxStep num_episode num_runs NumAction Length LL P_C landa
global Q_LCRL Q_XL Q_YL
global Array_CI_p M_Array m_Array D_Array ChooseSpace
global Q_UCRL Q_XU Q_YU
global Number_X_Action Number_X2NX_Action Trns_X2NX_Action Number_Y_Action Number_Y2NY_Action Trns_Y2NY_Action Reward_X_Action Reward_Y_Action
global Numsubspaces Q_XY Q_XI Q_YI Q_I
global NumIR Q_XYU Q_XYL Q_XIU Q_XIL Q_YIU Q_YIL Q_IU Q_IL CountW
global Q_Ir Q_IrU Q_IrL Q_Id Q_IdU Q_IdL Q_Il Q_IlU Q_IlL
global Number_Ir_Action Number_Ir2NIr_Action Number_Id_Action Number_Id2NId_Action Number_Il_Action Number_Il2NIl_Action
global Trns_Ir2NIr_Action Trns_Id2NId_Action Trns_Il2NIl_Action Reward_Ir_Action Reward_Id_Action Reward_Il_Action
global MINReward_Ir_Action MINReward_Id_Action MINReward_Il_Action MAXReward_Ir_Action MAXReward_Id_Action MAXReward_Il_Action


% Policy = struct('type','Boltzman','parameter',epsilon); 
% Policy.parameter = 1 / sum(Number_S_Action(state.x, state.y, :)) ;
% if sum(Number_S_Action(state.x, state.y, :)) ==0
%     Policy.parameter = 1;
% end

Policy.parameter = 0.1;

flag=0;

% assign probability
P = zeros(Numsubspaces,NumAction); % 1 for x ---- 2 for y ---- 3 for joint

if strcmp(Policy.type,'e-greedy')==1
    P(:, :) = Policy.parameter/NumAction ;
    [~, ax]=max(Q_X(state.x, :));
    [~, ay]=max(Q_Y(state.y, :));
    [~, ai]=max(Q_I(state.IRu, :));
    [~, air]=max(Q_Ir(state.IRr, :));
    [~, aid]=max(Q_Id(state.IRd, :));
    [~, ail]=max(Q_Il(state.IRl, :));
%     [~, axy]=max(Q_XY(state.x, state.y,:)); 
%     [~, axi]=max(Q_XI(state.x, state.IR,:)); 
%     [~, ayi]=max(Q_YI(state.y, state.IR,:)); 
    [~, aj]=max(Q_BD(state.x, state.y, :));
    P(1, ax)=P(1, ax)+ 1-Policy.parameter ;
    P(2, ay)=P(2, ay)+ 1-Policy.parameter ;
    P(3, ai)=P(3, ai)+ 1-Policy.parameter ;
    P(4, air)=P(4, air)+ 1-Policy.parameter ;
    P(5, aid)=P(5, aid)+ 1-Policy.parameter ;
    P(6, ail)=P(6, ail)+ 1-Policy.parameter ;
    P(7, aj)=P(7, aj)+ 1-Policy.parameter ;

elseif strcmp(Policy.type,'Boltzman')==1
    % this if not be used
    for i=1 : NumAction
        P(1, :)= reshape(exp(QX(state.x, :)./Policy.parameter)./sum(exp(QX(state.x, :)./Policy.parameter)),1, NumAction);
        P(2, :)= reshape(exp(QY(state.y, :)./Policy.parameter)./sum(exp(QY(state.y, :)./Policy.parameter)),1, NumAction);
        P(3, :)= reshape(exp(Q2(state.x, state.y, :)./Policy.parameter)./sum(exp(Q2(state.x, state.y, :)./Policy.parameter)),1, NumAction);
    end
end


% assign weight
W = zeros(Numsubspaces,NumAction); % 1 for x ---- 2 for y ---- 3 for joint

% Dif_XY= Q_XYU - Q_XYL;
% Dif_XI= Q_XIU - Q_XIL;
% Dif_YI= Q_YIU - Q_YIL;
Dif_X= Q_XU - Q_XL;
Dif_Y= Q_YU - Q_YL;
Dif_I= Q_IU - Q_IL;
Dif_Ir= Q_IrU - Q_IrL;
Dif_Id= Q_IdU - Q_IdL;
Dif_Il= Q_IlU - Q_IlL;
Dif_J= abs(Q_UCRL - Q_LCRL);

Intsx =0;
Intsy =0;
IntsI=0;
IntsXY=0;
IntsXI=0;
IntsYI=0;


intersecX=0;
intersecY=0;
intersecXY=0;
intersecXI=0;
intersecYI=0;
intersecI=0;
intersecIr=0;
intersecId=0;
intersecIl=0;
     
for i=1 : NumAction
    if ~(Q_XU(state.x, i)< Q_LCRL(state.x, state.y, i) || Q_XL(state.x, i)> Q_UCRL(state.x, state.y, i))
        if  Q_XL(state.x, i)<= Q_LCRL(state.x, state.y, i)
            if Q_XU(state.x, i)<= Q_UCRL(state.x, state.y, i)
                intersecX = Q_XU(state.x, i)- Q_LCRL(state.x, state.y,  i);
            else
                intersecX = Q_UCRL(state.x, state.y, i) - Q_LCRL(state.x, state.y,i);
            end
        else
            if Q_XU(state.x, i)<= Q_UCRL(state.x, state.y,  i)
                intersecX = Q_XU(state.x, i)- Q_XL(state.x, i);
            else
                intersecX = Q_UCRL(state.x, state.y,  i) - Q_XL(state.x, i);
            end
        end
        Intsx = intersecX/Dif_X(state.x, i);
        if Dif_X(state.x, i)<= 0.05
            Intsx = 1;
        end
    end
    if ~(Q_YU(state.y, i)< Q_LCRL(state.x, state.y, i) || Q_YL(state.y, i)> Q_UCRL(state.x, state.y, i))
        if  Q_YL(state.y, i)<= Q_LCRL(state.x, state.y, i)
            if Q_YU(state.y, i)<= Q_UCRL(state.x, state.y,  i)
                intersecY = Q_YU(state.y, i)- Q_LCRL(state.x, state.y, i);
            else
                intersecY = Q_UCRL(state.x, state.y,  i) - Q_LCRL(state.x, state.y,  i);
            end
        else
            if Q_YU(state.y, i)<= Q_UCRL(state.x, state.y,  i)
                intersecY = Q_YU(state.y, i)- Q_YL(state.y, i);
            else
                intersecY = Q_UCRL(state.x, state.y,  i) - Q_YL(state.y, i);
            end
        end
        Intsy = intersecY/Dif_Y(state.y, i);
        if Dif_Y(state.y, i) <= 0.05
            Intsy = 1;
        end
    end
    
    if ~(Q_IU(state.IRu, i)< Q_LCRL(state.x, state.y, i) || Q_IL(state.IRu, i)> Q_UCRL(state.x, state.y, i))
        if  Q_IL(state.IRu, i)<= Q_LCRL(state.x, state.y, i)
            if Q_IU(state.IRu, i)<= Q_UCRL(state.x, state.y,  i)
                intersecI = Q_IU(state.IRu, i)- Q_LCRL(state.x, state.y,  i);
            else
                intersecI = Q_UCRL(state.x, state.y, i) - Q_LCRL(state.x, state.y, i);
            end
        else
            if Q_IU(state.IRu, i)<= Q_UCRL(state.x, state.y, i)
                intersecI = Q_IU(state.IRu, i)- Q_IL(state.IRu, i);
            else
                intersecI = Q_UCRL(state.x, state.y, i) - Q_IL(state.IRu, i);
            end
        end
        IntsI = intersecI/Dif_I(state.IRu, i);
        if Dif_I(state.IRu, i) <= 0.05
            IntsI = 1;
        end
    end
    
    if ~(Q_IrU(state.IRr, i)< Q_LCRL(state.x, state.y, i) || Q_IrL(state.IRr, i)> Q_UCRL(state.x, state.y, i))
        if  Q_IrL(state.IRr, i)<= Q_LCRL(state.x, state.y, i)
            if Q_IrU(state.IRr, i)<= Q_UCRL(state.x, state.y,  i)
                intersecIr = Q_IrU(state.IRr, i)- Q_LCRL(state.x, state.y,  i);
            else
                intersecIr = Q_UCRL(state.x, state.y, i) - Q_LCRL(state.x, state.y, i);
            end
        else
            if Q_IrU(state.IRr, i)<= Q_UCRL(state.x, state.y, i)
                intersecIr = Q_IrU(state.IRr, i)- Q_IrL(state.IRr, i);
            else
                intersecIr = Q_UCRL(state.x, state.y, i) - Q_IrL(state.IRr, i);
            end
        end
        IntsIr = intersecIr/Dif_Ir(state.IRr, i);
        if Dif_Ir(state.IRr, i) <= 0.05
            IntsIr = 1;
        end
    end
    
    if ~(Q_IdU(state.IRd, i)< Q_LCRL(state.x, state.y, i) || Q_IdL(state.IRd, i)> Q_UCRL(state.x, state.y, i))
        if  Q_IdL(state.IRd, i)<= Q_LCRL(state.x, state.y, i)
            if Q_IdU(state.IRd, i)<= Q_UCRL(state.x, state.y,  i)
                intersecId = Q_IdU(state.IRd, i)- Q_LCRL(state.x, state.y,  i);
            else
                intersecId = Q_UCRL(state.x, state.y, i) - Q_LCRL(state.x, state.y, i);
            end
        else
            if Q_IdU(state.IRd, i)<= Q_UCRL(state.x, state.y, i)
                intersecId = Q_IdU(state.IRd, i)- Q_IdL(state.IRd, i);
            else
                intersecId = Q_UCRL(state.x, state.y, i) - Q_IdL(state.IRd, i);
            end
        end
        IntsId = intersecId/Dif_Id(state.IRd, i);
        if Dif_Id(state.IRd, i) <= 0.05
            IntsId = 1;
        end
    end
    
    if ~(Q_IlU(state.IRl, i)< Q_LCRL(state.x, state.y, i) || Q_IlL(state.IRl, i)> Q_UCRL(state.x, state.y, i))
        if  Q_IlL(state.IRl, i)<= Q_LCRL(state.x, state.y, i)
            if Q_IlU(state.IRl, i)<= Q_UCRL(state.x, state.y,  i)
                intersecIl = Q_IlU(state.IRl, i)- Q_LCRL(state.x, state.y,  i);
            else
                intersecIl = Q_UCRL(state.x, state.y, i) - Q_LCRL(state.x, state.y, i);
            end
        else
            if Q_IlU(state.IRl, i)<= Q_UCRL(state.x, state.y, i)
                intersecIl = Q_IlU(state.IRl, i)- Q_IlL(state.IRl, i);
            else
                intersecIl = Q_UCRL(state.x, state.y, i) - Q_IlL(state.IRl, i);
            end
        end
        IntsIl = intersecIl/Dif_Il(state.IRl, i);
        if Dif_Il(state.IRl, i) <= 0.05
            IntsIl = 1;
        end
    end
        
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    
    x1= ( (Dif_J(state.x, state.y, i)) / Dif_X(state.x, i) ) ;
     y1 = ( Dif_J(state.x, state.y, i)) / Dif_Y(state.y, i)  ;
    i1 =  ( Dif_J(state.x, state.y, i)) / Dif_I(state.IRu, i)  ;
    ir1 =  ( Dif_J(state.x, state.y, i)) / Dif_Ir(state.IRr, i)  ;
    id1 =  ( Dif_J(state.x, state.y, i)) / Dif_Id(state.IRd, i)  ;
    il1 =  ( Dif_J(state.x, state.y, i)) / Dif_Il(state.IRl, i)  ;
    
     
     
     x2= abs(Q_BD(state.x, state.y, i)- Q_X(state.x, i)) /intersecX ;
     y2= abs(Q_BD(state.x, state.y, i)- Q_Y(state.y, i)) /intersecY ;
     
    
         if 2*x2>1
             x2=1/2;
         end
         if 2*y2>1
             y2=1/2;
         end
        
         x6 = -erfinv(2*x2 - 1);
         y6 = -erfinv(2*y2 - 1);


         if x6>= 1
             x6=1;
         elseif x6<1
             x6=0;
         end
         if y6>=1
             y6=1;
         elseif y6<1
             y6=0;
         end
     
      %%%%%%%%%%%%%% X %%%%%%%%%%%%%%%%%%%%%%%%%%
%      if Number_S_Action( state.x, state.y, i)> 1 %> 0 %>-1 %> 1
%          x2= abs(Q_BD(state.x, state.y, i)- Q_X(state.x, i)) /intersecX ;
%           if 2*x2>1
%              x2=1/2;
%          end
%          x6 = -erfinv(2*x2 - 1);
%           if x6>=10
%              x6=10;
%           elseif x6<1
%              x6=0;
%           end
%      else 
%         x6=10.2;
%      end
     %%%%%%%%%%%%%%% Y %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%      if Number_S_Action( state.x, state.y, i)> 1 %> 0 %>-1 %> 1
%          y2= abs(Q_BD(state.x, state.y, i)- Q_Y(state.y, i)) /intersecY ;
%          if 2*y2>1
%              y2=1/2;
%          end
%          y6 = -erfinv(2*y2 - 1);
%          if y6>=10
%              y6=10;
%          elseif y6<1
%              y6=0;
%          end
%      else 
%         y6=10.2;
%      end
     
     %%%%%%%%%%%%%% IR %%%%%%%%%
     if Number_S_Action( state.x, state.y, i) >= 0 %> 0 %>-1 %> 1  
         
%          x2= abs(Q_BD(state.x, state.y, i)- Q_X(state.x, i)) /intersecX ;
%          y2= abs(Q_BD(state.x, state.y, i)- Q_Y(state.y, i)) /intersecY ;
%      
%     
%          if 2*x2>1
%              x2=1/2;
%          end
%          if 2*y2>1
%              y2=1/2;
%          end
%         
%          x6 = -erfinv(2*x2 - 1);
%          y6 = -erfinv(2*y2 - 1);
% 
% 
%          if x6>= 1
%              x6=1;
%          elseif x6<1
%              x6=0;
%          end
%          if y6>=1
%              y6=1;
%          elseif y6<1
%              y6=0;
%          end
         
         i2= abs(Q_BD(state.x, state.y, i)- Q_I(state.IRu, i)) /intersecI ;
          if 2*i2>1
             i2=1/2;
         end
         i6 = -erfinv(2*i2 - 1);
          if i6>=1
             i6=1;
         elseif i6<1
%              i6=0;
          end
         
          ir2= abs(Q_BD(state.x, state.y, i)- Q_Ir(state.IRr, i)) /intersecIr ;
          if 2*ir2>1
             ir2=1/2;
         end
         ir6 = -erfinv(2*ir2 - 1);
          if ir6>=1
             ir6=1;
         elseif ir6<1
%              ir6=0;
          end
         
          id2= abs(Q_BD(state.x, state.y, i)- Q_Id(state.IRd, i)) /intersecId ;
          if 2*id2>1
             id2=1/2;
         end
         id6 = -erfinv(2*id2 - 1);
          if id6>=1
             id6=1;
         elseif id6<1
%              id6=0;
         end
         
          il2= abs(Q_BD(state.x, state.y, i)- Q_Il(state.IRl, i)) /intersecIl ;
          if 2*il2>1
             il2=1/2;
         end
         il6 = -erfinv(2*il2 - 1);
         if il6>=1
             il6=1;
         elseif il6<1
%              il6=0;
         end
         
     else 
%          x6=1;
%          y6= 1;
         i6=1;
         ir6=1;
         id6=1;
         il6=1;
     end
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
     
      W(1, i)= x1 * x6 ;
      W(2, i)= y1 * y6 ;
      W(3, i)= i1 * i6;
      W(4, i)= ir1 * ir6;
      W(5, i)= id1 * id6;
      W(6, i)= il1 * il6;
      
      if  (Dif_J(state.x, state.y, i)) / Dif_X(state.x, i) < 0.9
          W(1, i)=0;
      end
     if Dif_J(state.x, state.y, i) / Dif_Y(state.y, i) < 0.9
         W(2, i)=0;
     end
     if Dif_J(state.x, state.y, i) / Dif_I(state.IRu, i)  < 0.9
         W(3, i)=0;
     end
      if Dif_J(state.x, state.y, i) / Dif_Ir(state.IRr, i)  < 0.9
         W(4, i)=0;
      end
      if Dif_J(state.x, state.y, i) / Dif_Id(state.IRd, i)  < 0.9
         W(5, i)=0;
      end
      if Dif_J(state.x, state.y, i) / Dif_Il(state.IRl, i)  < 0.9
         W(6, i)=0;
      end
        
     W(7, i)= 1 ;
     
      maxW=1;
      indW=7;
      for j=1:6
          if (W(j, i)>= maxW && CountW(j) <= Thr)
              maxW = W(j, i);
              indW = j;
          end
          W(j, i) =0;
      end
     W(7,i) =0;
     W(indW, i)=1;
%      if indW==4
%          W(7,i) =1;
%      end
%      if W(7, i)==1 && W(4, i)==0
%          W(4, i)
%      end
         
    
     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    


end

WP= W .* P;
Prob = sum (WP(:,:), 1);
Prob = Prob./sum(Prob);

% % flag=0;
% -- find best action acccording probability
if flag==0 || 1
    rnd=rand(1);
    for i=1 : NumAction
        if rnd<=sum(Prob(1:i))
            act=i;
            flag=1;
            %fprintf('%d\n', sum(Prob(1:i)));
            break;
        end
    end
% -- find just max probability
%     [~, act]=max(Prob);
end




 if act==1
    action='u';
elseif act==2
    action='r';
elseif act==3
    action='d';
elseif act==4
    action='l';
else
    action='n';
end
charaction=action;
numaction=act;
end





