function [ lus ] = LUS( CIs , M  )
%Choose the source with the smallest confidence interval
% mos: 0-joint space  numbers-sensor numbers

    MLength = M(2)-M(1);
    lus = 0;
    if size(CIs,1)>0
        lengths = CIs(:,2) - CIs(:,1);
        [CIMinLength,smallest] = min(lengths);
        CIMaxLength = max(lengths);
        if CIMaxLength == CIMinLength
            smallest = ceil(rand*size(CIs,1));
        end
%         %right now I'm not using the upper M constraint here
%         if CIMinLength <= MLength
%             lus = CIs(smallest,3);
%         end        
        
        
        if CIMinLength <= MLength && CIs(smallest,2) < M(2) 
            lus = CIs(smallest,3);
        end
    end

    
end

