%% this main is for Rand and Normal of choose-action for jointSpace

clc
clear

global  Q Q_B Number_S_Action Number_S2NS_Action Trns_S2NS_Action Reward_S_Action Ret NRet BestR alpha gama E Q_BD Q_UCRL Q_LCRL gama_s
global MaxStep num_episode num_runs numAction Length LL P_C landa Reward_X_Action Reward_Y_Action
global Array_CI_p M_Array m_Array D_Array ChooseSpace
global Q_X Q_Y Q_XL Q_YL Q_XU Q_YU
global DD1 DD2 DD3
global Number_X_Action Number_X2NX_Action Trns_X2NX_Action Number_Y_Action Number_Y2NY_Action Trns_Y2NY_Action 
global NumAction
global EmptydX EmptydY
global WeightE WeightProbE WeightES WeightProbES
global aveRewardArraySMB

 c=clock;
rand('state',sum(1000*mod(c(end),1)));

Env();
initial;

% MakeStartingState();

load('StartingstateRoomRnd.mat') % 30 step

% load('StartingstateRoom9Rnd.mat'); % 50step

% load('StartingstateVeryBigEnvRnd.mat') % 35 step

% load('StartingstateVeryBigEnvOBSRnd.mat') % 35 step

MaxStep = 30;


ChooseSpaces=zeros(num_episode, MaxStep, num_runs);
rewards = zeros(num_runs,num_episode);
steps = zeros(num_runs,num_episode);
XP = zeros(MaxStep,4,num_episode,num_runs); %  [reward,state.x,state.y,action]



aveRewardArraySMB = zeros(num_runs , num_episode );
rewardArrayMB = zeros(num_runs , num_episode );

tic;
meanrewards=zeros(3, num_runs);

 for runs=1:num_runs
        
        fprintf('run Q_Bellman \n');
        initial;
        [rewards(runs, :), steps(runs, :), XP(:, :, :, runs)] =Q_Bellman(); % normal choose action
        QBD=Q_BD;
      
         
        fprintf('Runs %d for Bellman . Average reward : %f\n',runs,mean(rewards(runs, :)));
%         fprintf('Runs %d for Bellman_old . Average reward : %f\n',runs,mean(rewards(2, :)));

        meanrewards(1, runs)= mean(rewards(runs, :));
%         meanrewards(2, runs)= mean(rewards(2, :));
    

        aveRewardArraySMB(runs,1) = rewards(runs, 1);
        for i=2:num_episode         
            aveRewardArraySMB(runs,i) = ((i-1)*aveRewardArraySMB(runs,i-1)+rewards(runs, i))/i;
        end

    
    % create reward array
    rewardArrayMB(runs,:) = rewards(runs, :);  


end
tim=toc/num_runs;
%fprintf('Total Average reward : %d\n',mean(mean(rewardArray)));

%% averaging and plotting...

% extendResults;

fig=figure;
hold on
plot(mean(aveRewardArraySMB),'b','LineWidth',2)
legend('MB', 'location', 'best')
grid on
xlabel('#episode', 'FontSize', 12)
ylabel('Average of accumulated reward', 'FontSize', 12)

saveas(fig,strcat('Avg_MB','.fig'));


