function [rewards , steps, XP] =Q_Bellman()

% Bellman learning

global  Q Q_B Number_S_Action Number_S2NS_Action Trns_S2NS_Action Reward_S_Action Ret NRet BestR alpha gama delta E Q_BD
global MaxStep num_episode num_runs numAction Length LL P_C landa Startingstate fg_goal
global NumAction

rewards = zeros(1,num_episode);
steps = zeros(1,num_episode);
XP = zeros(MaxStep,4,num_episode);
parameter=1;
Policy = struct('type','e-greedy','parameter',parameter); 

for ep=1 : num_episode
    
    Policy.parameter = parameter / ep;
    step_num = 0;
    state = struct('x',Startingstate.x(ep),'y',Startingstate.y(ep)); 
        
    while (step_num <MaxStep && fg_goal==0)

        step_num=step_num+1;
        [charaction, numaction]=Choose_action(Policy, state, Q_B);   % policy is based on Q_BD
        [reward, nextState] = performAction_Stochastic(state,charaction);
          % Updating
         postActionUpdate(state, nextState, reward, numaction);
         
          Trns=reshape(Trns_S2NS_Action(state.x ,state.y, :, :, numaction), size(Trns_S2NS_Action, 3), size(Trns_S2NS_Action, 4));
          QN=reshape(max(Q_B(:, :,:), [], 3), size(Q_B, 1), size(Q_B, 2));
          RN=reshape(Reward_S_Action(state.x ,state.y, :, :, numaction), size(Reward_S_Action, 3), size(Reward_S_Action, 4));
          MM= sum(sum(Trns.* (RN + gama*QN))) ;
          Q_B(state.x ,state.y ,numaction) = MM;      
       
          XP(step_num,:, ep)=[reward, state.x ,state.y ,numaction];
          rewards(ep) = rewards(ep) + reward;
          state= nextState; 

    end

     fg_goal=0;
     steps (1,ep) = step_num ;
     Q_B =VI(Q_B, Trns_S2NS_Action, Reward_S_Action, 0, gama, ep);
    
end

end