function [rewards , steps,XP] =Q_Bellman_sub_Thr(Delta, T)

% Bellman learning

global  Q Q_B Number_S_Action Number_S2NS_Action Trns_S2NS_Action Reward_S_Action Ret NRet BestR alpha gama delta E Q_BD Q_X Q_Y gama_s
global MaxStep num_episode num_runs NumAction Length LL P_C landa Environment
global Q_LCRL Q_XL Q_YL
global Array_CI_p M_Array m_Array D_Array ChooseSpace
global Q_UCRL Q_XU Q_YU
global DD1 DD2 DD3
global EmptydX EmptydY
global Number_X_Action Number_X2NX_Action Trns_X2NX_Action Number_Y_Action Number_Y2NY_Action Trns_Y2NY_Action Reward_X_Action Reward_Y_Action
global Startingstate fg_goal
global WeightE WeightProbE WeightES WeightProbES Numsubspaces
global Dif_Jiont Dif_Y Dif_X
global MAXReward_S_Action MAXReward_X_Action MAXReward_Y_Action MINReward_S_Action MINReward_X_Action MINReward_Y_Action
global CountWX CountWY
  
Thr = 1000;
EmptydX=[];
EmptydY=[];

rewards = zeros(1,num_episode);
steps = zeros(1,num_episode);
% XP = zeros(num_episode,MaxStep,4); %  [reward,state.x,state.y,action]
XP = zeros(MaxStep,4,num_episode); %  [reward,state.x,state.y,action]

 
t=1;
% parameter=10;
% Policy = struct('type','Boltzman','parameter',parameter); 
parameter=1;
Policy = struct('type','e-greedy','parameter',parameter); 

WeightE=zeros(Numsubspaces, num_episode);
WeightProbE=zeros(Numsubspaces, num_episode);
WeightES=zeros(Numsubspaces, 1);
WeightProbES=zeros(Numsubspaces, 1);
count=0;

[Q_UCRL, Q_XU, Q_YU]=OptS_Sub_Known(Q_BD, Trns_S2NS_Action,Reward_S_Action,0,gama,1,  Q_X, Q_Y, Trns_X2NX_Action,Reward_X_Action, Trns_Y2NY_Action,Reward_Y_Action, gama_s, gama_s, Environment,Q_XU, Q_YU, Q_UCRL,Delta,Number_S_Action, Number_X_Action, Number_Y_Action,MINReward_S_Action, MAXReward_S_Action, MINReward_X_Action, MAXReward_X_Action , MINReward_Y_Action, MAXReward_Y_Action);
[Q_LCRL, Q_XL, Q_YL]=PesS_Sub_Known(Q_BD, Trns_S2NS_Action,Reward_S_Action,0,gama,1,  Q_X, Q_Y, Trns_X2NX_Action,Reward_X_Action, Trns_Y2NY_Action,Reward_Y_Action, gama_s, gama_s, Environment,Q_XL, Q_YL, Q_LCRL,Delta,Number_S_Action, Number_X_Action, Number_Y_Action,MINReward_S_Action, MAXReward_S_Action, MINReward_X_Action, MAXReward_X_Action , MINReward_Y_Action, MAXReward_Y_Action);

CountWX=0;   
CountWY=0;   
    
for ep=1 : num_episode
    
   
    Policy.parameter = parameter / ep;
    %epsilon=0.1;
    step_num = 0;
    reward=0;
    V =zeros(LL, LL, NumAction); % Number of transition from each State for each Action in this episode
    
    Dif_Jiont= Q_UCRL - Q_LCRL;
    Dif_X= Q_XU - Q_XL;
    Dif_Y= Q_YU - Q_YL;
   

    state = struct('x',Startingstate.x(ep),'y',Startingstate.y(ep)); 
        
    while (step_num <MaxStep && fg_goal==0)
        
        count = count+1;
         
        step_num=step_num+1;
       
       NSA = sum (Number_S_Action( state.x, state.y, :));
       if NSA < T
            [charaction, numaction, WP, W]= Choose_action_MoBLeS( Policy, state, Q_BD, Q_X, Q_Y, Thr) ;
       else
            [charaction, numaction]=Choose_action(Policy, state, Q_BD)  ;
            W = zeros(Numsubspaces,NumAction); % 1 for x ---- 2 for y ---- 3 for joint
            WP = zeros(Numsubspaces,NumAction); % 1 for x ---- 2 for y ---- 3 for joint
            W(1, :)=0; WP(1, :)=0;
            W(2, :)=0; WP(2, :)=0;
            W(3, :)=1; WP(3, :)=1;
       end



        [reward, nextState] = performAction_Stochastic(state,charaction);
          
        postActionUpdate(state, nextState, reward, numaction);
         
      Trns=reshape(Trns_S2NS_Action(state.x ,state.y, :, :, numaction), size(Trns_S2NS_Action, 3), size(Trns_S2NS_Action, 4));
      QN=reshape(max(Q_BD(:, :,:), [], 3), size(Q_BD, 1), size(Q_BD, 2));
      RN=reshape(Reward_S_Action(state.x ,state.y, :, :, numaction), size(Reward_S_Action, 3), size(Reward_S_Action, 4));
      MM= sum(sum(Trns.* (RN + gama*QN))) ;
      Q_BD(state.x ,state.y ,numaction) = MM;
      
      Trnsx=reshape(Trns_X2NX_Action(state.x , :, numaction), size(Trns_X2NX_Action, 2), 1);
      rewardx = reshape(Reward_X_Action(state.x , :, numaction), size(Reward_X_Action, 2), 1);
%       QNX = (1-epsilon).* (max(Q_X(:,:), [], 2)) + (epsilon/NumAction).* (sum(Q_X(:,:), 2));
      QNX = (1-0).* (max(Q_X(:,:), [], 2)) + (0/NumAction).* (sum(Q_X(:,:), 2));
      MMD = sum((Trnsx.* (rewardx + gama_s*QNX))); 
      Q_X(state.x ,numaction) = MMD ;

       Trnsy=reshape(Trns_Y2NY_Action(state.y, :, numaction), size(Trns_Y2NY_Action, 2), 1);
      rewardy= reshape(Reward_Y_Action(state.y , :, numaction), size(Reward_Y_Action, 2), 1);
      QNY= (1-0).* (max(Q_Y(:,:), [], 2)) + (0/NumAction).* (sum(Q_Y(:,:), 2));
      MMDY= sum((Trnsy.* (rewardy + gama_s*QNY))); 
      Q_Y(state.y ,numaction) = MMDY ;
      
      OptSolveTetaSubeachStep(Delta, ep, state, numaction);
      PessimisticSolveSubeachStep(Delta, ep, state, numaction);
        
        V( state.x,  state.y, numaction) = V( state.x,  state.y, numaction)+1 ;
        t = t+1;
        XP(step_num,:,ep)=[reward, state.x ,state.y ,numaction];
        rewards(ep) = rewards(ep) + reward;
        state= nextState; 
        
        % Find Weight
        WeightE(1, ep)= WeightE(1, ep) + W(1, numaction);
        WeightE(2, ep)= WeightE(2, ep) + W(2, numaction);
        WeightE(3, ep)= WeightE(3, ep) + W(3, numaction);
        
        WP = WP./ repmat(sum (WP(:,:), 1), 3, 1);
        WeightProbE(1, ep)= WeightProbE(1, ep) + WP(1, numaction);
        WeightProbE(2, ep)= WeightProbE(2, ep) + WP(2, numaction);
        WeightProbE(3, ep)= WeightProbE(3, ep) + WP(3, numaction);
        
        WeightES(1, count)= W(1, numaction);
        WeightES(2, count)= W(2, numaction);
        WeightES(3, count)= W(3, numaction);
        
        WeightProbES(1, count)= WP(1, numaction);
        WeightProbES(2, count)= WP(2, numaction);
        WeightProbES(3, count)= WP(3, numaction);
        
    end
    fg_goal=0;
    steps (1,ep) = step_num ;
    
    if  WeightE(1, ep)<  WeightE(3, ep)
        CountWX=CountWX+1;
    end
    if  WeightE(2, ep)<  WeightE(3, ep)
        CountWY=CountWY+1;
    end
    
 
    [Q_BD, Q_X, Q_Y]=VI_Sub(Q_BD,Trns_S2NS_Action,Reward_S_Action,0,gama,ep,  Q_X, Q_Y, Trns_X2NX_Action,Reward_X_Action, Trns_Y2NY_Action,Reward_Y_Action, gama_s, gama_s, Environment);
    [Q_UCRL, Q_XU, Q_YU]=OptS_Sub_Known(Q_BD, Trns_S2NS_Action,Reward_S_Action,0,gama,1,  Q_X, Q_Y, Trns_X2NX_Action,Reward_X_Action, Trns_Y2NY_Action,Reward_Y_Action, gama_s, gama_s, Environment,Q_XU, Q_YU, Q_UCRL,Delta,Number_S_Action, Number_X_Action, Number_Y_Action,MINReward_S_Action, MAXReward_S_Action, MINReward_X_Action, MAXReward_X_Action , MINReward_Y_Action, MAXReward_Y_Action);
    [Q_LCRL, Q_XL, Q_YL]=PesS_Sub_Known(Q_BD, Trns_S2NS_Action,Reward_S_Action,0,gama,1,  Q_X, Q_Y, Trns_X2NX_Action,Reward_X_Action, Trns_Y2NY_Action,Reward_Y_Action, gama_s, gama_s, Environment,Q_XL, Q_YL, Q_LCRL,Delta,Number_S_Action, Number_X_Action, Number_Y_Action,MINReward_S_Action, MAXReward_S_Action, MINReward_X_Action, MAXReward_X_Action , MINReward_Y_Action, MAXReward_Y_Action);

    
end


end