function [rewards , steps, XP] =Q_landa_Ped(Landa, delta, AlphaType, AlphaTypeSub)
% TD(landa) Learning
% Q-Learning


global  Q Q_B Number_S_Action Number_S2NS_Action Trns_S2NS_Action Reward_S_Action BestR alpha gama E
global MaxStep num_episode num_runs numAction Length LL P_C landa Startingstate fg_goal
global NumAction  Q_X Q_Y E_X E_Y gama_s TINV_VALUES Number_X_Action Number_Y_Action
global NRet Ret SumJ SqrJ RetX NRetX SumX SqrX RetY NRetY SumY SqrY



TINV_VALUES = tinv(1-(delta/2),1:100000);
landa=Landa;
rewards = zeros(1,num_episode);
steps = zeros(1,num_episode);
parameter=1;
Policy = struct('type','e-greedy','parameter',parameter); 
XP = zeros(MaxStep,4,num_episode);
for ep=1 : num_episode
    
    Policy.parameter = parameter / ep;
    
    % XP = zeros(MaxStep,4); %  [reward,state.x,state.y,action]
    step_num = 0;
    reward=0;
    % create an episode
    % first State
    state = struct('x',Startingstate.x(ep),'y',Startingstate.y(ep)); 
    [charaction, numaction]=Choose_action_Ped(Policy, state);   % policy is based on Q_BD
    %[charaction, numaction] = Choose_action(epsilon, state, Q);  %Choose_action(0, state, Q_UCRL);
%     E =zeros(LL, LL, NumAction); 
    while (step_num <MaxStep && fg_goal==0)
  %  while ( reward~=BestR)
  
         if AlphaType==1
            alpha = 1./(1+Number_S_Action);
        elseif AlphaType==2
            alpha = sqrt(1./(1+Number_S_Action));
        elseif AlphaType==3
            alpha = 1./(1+ sqrt(Number_S_Action));
        elseif AlphaType==4
            alpha = 1./(1+ep);
        elseif AlphaType==5
            alpha = sqrt(1./(1+ep));
        elseif AlphaType==6
            alpha = 1./(1+ sqrt(ep));
        elseif AlphaType==7
            alpha = 0.1;
%         elseif AlphaType==8
%             alpha = 0.9;
%         elseif AlphaType==9
%             alpha = 0.7;
         end
         if AlphaTypeSub==1
            alphaX = (1./(1+Number_X_Action));
            alphaY = (1./(1+Number_Y_Action));
        elseif AlphaTypeSub==2
            alphaX = sqrt(1./(1+Number_X_Action));
            alphaY = sqrt(1./(1+Number_Y_Action));
        elseif AlphaTypeSub==3
            alphaX = 1./(1+ sqrt(Number_X_Action));
            alphaY = 1./(1+ sqrt(Number_Y_Action));
        elseif AlphaTypeSub==4
            alphaX = 1./(1+ log10(Number_X_Action+1));
            alphaY = 1./(1+ log10(Number_Y_Action+1));
        elseif AlphaTypeSub==5
            NumX=sum(Number_X_Action, 2);
            NumXVisited=find(NumX);
            NumY=sum(Number_Y_Action, 2);
            NumYVisited=find(NumY);
            alphaX = (1./(1+(Number_X_Action./(numel(NumYVisited)+1))));
            alphaY = (1./(1+(Number_Y_Action./(numel(NumXVisited)+1))));
        elseif AlphaTypeSub==6
            NumX=sum(Number_X_Action, 2);
            NumXVisited=find(NumX);
            NumY=sum(Number_Y_Action, 2);
            NumYVisited=find(NumY);
            alphaX = sqrt(1./(1+(Number_X_Action./(numel(NumYVisited)+1))));
            alphaY = sqrt(1./(1+(Number_Y_Action./(numel(NumXVisited)+1))));
        elseif AlphaTypeSub==7
            NumX=sum(Number_X_Action, 2);
            NumXVisited=find(NumX);
            NumY=sum(Number_Y_Action, 2);
            NumYVisited=find(NumY);
            alphaX = (1./(1+ sqrt(Number_X_Action./(numel(NumYVisited)+1))));
            alphaY = (1./(1+ sqrt(Number_Y_Action./(numel(NumXVisited)+1))));
        elseif AlphaTypeSub==8
            NumX=sum(Number_X_Action, 2);
            NumXVisited=find(NumX);
            NumY=sum(Number_Y_Action, 2);
            NumYVisited=find(NumY);
            alphaX = (1./(1+log10(Number_X_Action./(numel(NumYVisited)+1)+1)));
            alphaY = (1./(1+log10(Number_Y_Action./(numel(NumXVisited)+1)+1)));
        elseif AlphaTypeSub==9
            alphaX = 0.1;
            alphaY = 0.1;
        end
  
  
        step_num=step_num+1;
        
        [reward, nextState] = performAction_Stochastic(state,charaction);
        [Ncharaction, Nnumaction]=Choose_action_Ped(Policy, nextState);   % policy is based on Q_BD
%          [Ncharaction, Nnumaction] = Choose_action(epsilon, nextState, Q);
         
         % Q(lambda)
         [~, action2]=max( Q(nextState.x, nextState.y, :) );
         aStar=action2(1, 1);
         diff=reward + gama* Q(nextState.x, nextState.y, aStar) - Q(state.x ,state.y ,numaction); 
         E(state.x ,state.y ,numaction) =  E(state.x ,state.y ,numaction)+1;
         Q = Q + (alpha*diff).* E ;
         if aStar==Nnumaction
             E= (gama*landa).*E;
         else
             E=0.*E;
         end
         
         % Q_X(lambda)
         [~, actionX2]=max( Q_X(nextState.x, :) );
         aStarX=actionX2(1, 1);
         diffX=reward + gama_s* Q_X(nextState.x, aStarX) - Q_X(state.x ,numaction); 
         E_X(state.x ,numaction) =  E_X(state.x , numaction)+1;
         Q_X = Q_X + (alphaX*diffX).* E_X ;
         if aStarX==Nnumaction
             E_X= (gama_s*landa).*E_X;
         else
             E_X=0.*E_X;
         end
         
          % Q_Y(lambda)
         [~, actionY2]=max( Q_Y(nextState.y, :) );
         aStarY=actionY2(1, 1);
         diffY=reward + gama_s* Q_Y(nextState.y, aStarY) - Q_Y(state.y ,numaction); 
         E_Y(state.y ,numaction) =  E_Y(state.y , numaction)+1;
         Q_Y = Q_Y + (alphaY*diffY).* E_Y ;
         if aStarY==Nnumaction
             E_Y= (gama_s*landa).*E_Y;
         else
             E_Y=0.*E_Y;
         end
         
           % Updating
         postActionUpdate(state, nextState, reward, numaction);
         
%          XP(step_num,:)=[reward, state.x ,state.y ,numaction];
          XP(step_num,:, ep)=[reward, state.x ,state.y ,numaction];
          
          rewards(ep) = rewards(ep) + reward;
          
         state= nextState;
         charaction=Ncharaction;
         numaction=Nnumaction;
                   
%           fprintf('State is %d %d\n',state.x, state.y);
    end
    
    fg_goal=0;
     steps (1,ep) = step_num ;
     % end
     % end of episode

     for i=1: step_num
        % calculate the future discounted reward
        discountedReward = 0;
        ctr=0;
        for j=i : step_num
            discountedReward = discountedReward + (gama^ctr) * XP(j,1, ep);
            ctr=ctr+1;
        end
   
        Ret(XP(i, 2,ep), XP(i, 3, ep), XP(i, 4, ep)) =(( Ret(XP(i, 2, ep), XP(i, 3, ep), XP(i, 4, ep)) * NRet(XP(i, 2, ep), XP(i, 3, ep), XP(i, 4, ep)) ) + discountedReward ) / (NRet(XP(i, 2, ep), XP(i, 3, ep), XP(i, 4, ep)) + 1) ;
        NRet(XP(i, 2, ep), XP(i, 3, ep), XP(i, 4, ep))=NRet(XP(i, 2, ep), XP(i, 3, ep), XP(i, 4, ep)) + 1;
        SumJ( XP(i, 2, ep), XP(i, 3, ep), XP(i, 4, ep) ) = SumJ( XP(i, 2, ep), XP(i, 3, ep), XP(i, 4, ep) ) + discountedReward;
        SqrJ(  XP(i, 2, ep), XP(i, 3, ep), XP(i, 4, ep) ) =  SqrJ(  XP(i, 2, ep), XP(i, 3, ep), XP(i, 4, ep))  +  discountedReward^2 ;
%         Q(XP(i, 2), XP(i, 3), XP(i, 4)) = Ret(XP(i, 2), XP(i, 3), XP(i, 4))  ;

        RetX(XP(i, 2,ep), XP(i, 4, ep)) =(( RetX(XP(i, 2, ep),  XP(i, 4, ep)) * NRetX(XP(i, 2, ep),  XP(i, 4, ep)) ) + discountedReward ) / (NRetX(XP(i, 2, ep), XP(i, 4, ep)) + 1) ;
        NRetX(XP(i, 2, ep), XP(i, 4, ep))=NRetX(XP(i, 2, ep), XP(i, 4, ep)) + 1;
        SumX( XP(i, 2, ep), XP(i, 4, ep) ) = SumX( XP(i, 2, ep), XP(i, 4, ep) ) + discountedReward;
        SqrX(  XP(i, 2, ep), XP(i, 4, ep) ) =  SqrX(  XP(i, 2, ep), XP(i, 4, ep))  +  discountedReward^2 ;
        
        RetY( XP(i, 3, ep), XP(i, 4, ep)) =(( RetY( XP(i, 3, ep), XP(i, 4, ep)) * NRetY(XP(i, 3, ep), XP(i, 4, ep)) ) + discountedReward ) / (NRetY(XP(i, 3, ep), XP(i, 4, ep)) + 1) ;
        NRetY(XP(i, 3, ep), XP(i, 4, ep))=NRetY(XP(i, 3, ep), XP(i, 4, ep)) + 1;
        SumY(XP(i, 3, ep), XP(i, 4, ep) ) = SumY(XP(i, 3, ep), XP(i, 4, ep) ) + discountedReward;
        SqrY(XP(i, 3, ep), XP(i, 4, ep) ) =  SqrY(XP(i, 3, ep), XP(i, 4, ep))  +  discountedReward^2 ;
        
     end
%         steps (1,ep) = step_num ;
    
    
end
 




