function [charaction, numaction] =Choose_action_Ped(Policy, state)
%uses history from global data and choose an appropriate action which is believed is the best action.
global  Q Q_B Number_S_Action Number_S2NS_Action Trns_S2NS_Action Reward_S_Action Ret NRet BestR alpha gama E Q_BD Q_UCRL Q_LCRL gama_s
global MaxStep num_episode num_runs numAction Length LL P_C landa
global Q_X Q_Y Q_XL Q_YL Q_XU Q_YU ChooseSpace
global Number_X_Action Number_X2NX_Action Trns_X2NX_Action Number_Y_Action Number_Y2NY_Action Trns_Y2NY_Action Reward_X_Action Reward_Y_Action
global NumAction Numsubspaces Startingstate
global MAXReward_S_Action MAXReward_X_Action MAXReward_Y_Action MINReward_S_Action MINReward_X_Action MINReward_Y_Action
global fg_goal Weights MaxR MinR E_X E_Y
global SumJ SqrJ RetX NRetX SumX SqrX RetY NRetY SumY SqrY
global TINV_VALUES Number_XY_Action
global Number_HP_Action Number_HP2HP_Action Number_hpe1_Action Number_hpe12hpe1_Action Number_hpe2_Action Number_hpe22hpe2_Action Number_hpe3_Action Number_hpe32hpe3_Action
global RetHP NRetHP SumHP SqrHP RetE1 NRetE1 SumE1 SqrE1 RetE2 NRetE2 SumE2 SqrE2 RetE3 NRetE3 SumE3 SqrE3
global Q_HP Q_HPU Q_HPL Q_hpe1 Q_hpe1U Q_hpe1L Q_hpe2 Q_hpe2U Q_hpe2L Q_hpe3 Q_hpe3U Q_hpe3L
global Q_de1 Q_XY E_XY
global RetDE1 NRetDE1 SumDE1 SqrDE1 RetDE2 NRetDE2 SumDE2 SqrDE2 RetDE3 NRetDE3 SumDE3 SqrDE3
global RetXY NRetXY SumXY SqrXY
global Number_DE1_Action Number_D1NDE1_Action Number_DE2_Action Number_D2NDE2_Action Number_DE3_Action Number_D3NDE3_Action
global Trns_D1NDE1_Action Trns_D2NDE2_Action Trns_D3NDE3_Action
global Reward_DE1_Action Reward_DE2_Action Reward_DE3_Action





    num_sensor = Numsubspaces-1;
    
    Visit_joint(1:NumAction) = Number_S_Action(state.x, state.y, state.HP, state.hpe1, :);
    
    Qtemp = zeros(1,NumAction);
    
    temp_OKtest = zeros(num_sensor, NumAction); % sensors which passed the test
    temp_MasterSensor =  zeros(num_sensor+1, NumAction); % the sensor that make the final decision (based on the decision making method)
    % I can add something to save the max and min q value source. but now I
    % like to test the test first
    
    % the following code uses T student interval as CI
    %% create confidence intervals for each action (real CIs and CIps(minus comment experiments) )
    for a = 1:NumAction
        
        %S1 X S2 X S3 CI
        if Visit_joint(a) < 2
            M1 = -realmax;
            M2 = realmax;
        else
            s = sqrt( ( Visit_joint(a) * SqrJ(state.x, state.y, state.HP, state.hpe1, a) - ( SumJ(state.x, state.y, state.HP, state.hpe1, a) )^2 ) / (Visit_joint(a)*(Visit_joint(a)-1)) );
            bound = TINV_VALUES(Visit_joint(a)-1) * s/sqrt(Visit_joint(a));
            M1 = Q(state.x, state.y, state.HP, state.hpe1, a) - bound;
            M2 = Q(state.x, state.y, state.HP, state.hpe1, a) + bound;
        end
        M1 = double(M1);
        M2 = double(M2);
        
        %confidence inteval for 3 sensors for performing the test (p in the name means : minus the common experience)
        CIp = zeros(num_sensor,2);
        %visit number for each sensors without the common experience
        vsp = zeros(num_sensor,1);
        
        %real confidence inteval
        CI = zeros(num_sensor,2);
        
      %  for i=1:num_sensor
            
            i=1;
            vsp(i) = Number_XY_Action(state.x, state.y, state.c, a) - Visit_joint(a);
            
            % CIps for performing the test
            if vsp(i) < 2
                CIp(i,1) = -realmax;
                CIp(i,2) = realmax;
            else
                temp_sumXp = SumXY(state.x, state.y, state.c, a) - SumJ(state.x, state.y, state.HP, state.hpe1, a);
                temp_sumX2p =  SqrXY(state.x, state.y, state.c, a) -  SqrJ(state.x, state.y, state.HP, state.hpe1, a);
                
                s = sqrt( ( vsp(i) * temp_sumX2p - ( temp_sumXp )^2 ) / (vsp(i)*(vsp(i)-1)) );
                bound = TINV_VALUES(vsp(i)-1) * s/sqrt(vsp(i));
                CIp(i,1) =  temp_sumXp/vsp(i) - bound;
                CIp(i,2) =  temp_sumXp/vsp(i) + bound;
            end
            
            %real CIs
            temp_visitnum = Number_XY_Action(state.x, state.y, state.c, a);
            if temp_visitnum < 2
                CI(i,1) = -realmax;
                CI(i,2) = realmax;
            else
                
                s = sqrt( ( temp_visitnum * SqrXY(state.x, state.y, state.c, a) - ( SumXY(state.x,state.y, state.c, a) )^2 ) / ( temp_visitnum*(temp_visitnum-1) ) );
                bound = TINV_VALUES(temp_visitnum-1) * s/sqrt(temp_visitnum);
                CI(i,1) =  Q_XY(state.x, state.y,state.c, a) - bound;
                CI(i,2) =  Q_XY(state.x, state.y,state.c, a) + bound;
            end
            
            CI = double(CI);
            
       % for HP
            i=2;
            vsp(i) = Number_HP_Action(state.HP, state.c, a) - Visit_joint(a);
            
            % CIps for performing the test
            if vsp(i) < 2
                CIp(i,1) = -realmax;
                CIp(i,2) = realmax;
            else
                temp_sumXp = SumHP(state.HP, state.c, a) - SumJ(state.x, state.y, state.HP, state.hpe1,a);
                temp_sumX2p =  SqrHP(state.HP, state.c, a) -  SqrJ(state.x, state.y, state.HP, state.hpe1, a);
                
                s = sqrt( ( vsp(i) * temp_sumX2p - ( temp_sumXp )^2 ) / (vsp(i)*(vsp(i)-1)) );
                bound = TINV_VALUES(vsp(i)-1) * s/sqrt(vsp(i));
                CIp(i,1) =  temp_sumXp/vsp(i) - bound;
                CIp(i,2) =  temp_sumXp/vsp(i) + bound;
            end
            
            %real CIs
            temp_visitnum = Number_HP_Action(state.HP, state.c, a);
            if temp_visitnum < 2
                CI(i,1) = -realmax;
                CI(i,2) = realmax;
            else
                
                s = sqrt( ( temp_visitnum * SqrHP(state.HP, state.c, a) - ( SumHP(state.HP, state.c, a) )^2 ) / ( temp_visitnum*(temp_visitnum-1) ) );
                bound = TINV_VALUES(temp_visitnum-1) * s/sqrt(temp_visitnum);
                CI(i,1) =  Q_HP(state.HP, state.c, a) - bound;
                CI(i,2) =  Q_HP(state.HP, state.c, a) + bound;
            end
            
            CI = double(CI);
       % end
       
         % for E1
            i=3;
            vsp(i) = Number_DE1_Action(state.de1, state.c, a) - Visit_joint(a);            
            % CIps for performing the test
            if vsp(i) < 2
                CIp(i,1) = -realmax;
                CIp(i,2) = realmax;
            else
                temp_sumXp = SumDE1(state.de1, state.c, a) - SumJ(state.x, state.y, state.HP, state.hpe1,  a);
                temp_sumX2p =  SqrDE1(state.de1, state.c, a) -  SqrJ(state.x, state.y, state.HP, state.hpe1, a);
                
                s = sqrt( ( vsp(i) * temp_sumX2p - ( temp_sumXp )^2 ) / (vsp(i)*(vsp(i)-1)) );
                bound = TINV_VALUES(vsp(i)-1) * s/sqrt(vsp(i));
                CIp(i,1) =  temp_sumXp/vsp(i) - bound;
                CIp(i,2) =  temp_sumXp/vsp(i) + bound;
            end           
            %real CIs
            temp_visitnum = Number_DE1_Action(state.de1, state.c, a);
            if temp_visitnum < 2
                CI(i,1) = -realmax;
                CI(i,2) = realmax;
            else                
                s = sqrt( ( temp_visitnum * SqrDE1(state.de1, state.c, a) - ( SumDE1(state.de1, state.c, a) )^2 ) / ( temp_visitnum*(temp_visitnum-1) ) );
                bound = TINV_VALUES(temp_visitnum-1) * s/sqrt(temp_visitnum);
                CI(i,1) =  Q_de1(state.de1, state.c, a) - bound;
                CI(i,2) =  Q_de1(state.de1, state.c, a) + bound;
            end            
            CI = double(CI);
       % end
       
%        % for E2
%             i=5;
%             vsp(i) = Number_hpe2_Action(state.hpe2, state.c, a) - Visit_joint(a);            
%             % CIps for performing the test
%             if vsp(i) < 2
%                 CIp(i,1) = -realmax;
%                 CIp(i,2) = realmax;
%             else
%                 temp_sumXp = SumE2(state.hpe2, state.c, a) - SumJ(state.x, state.y, state.HP, state.hpe1, a);
%                 temp_sumX2p =  SqrE2(state.hpe2, state.c, a) -  SqrJ(state.x, state.y, state.HP, state.hpe1, a);
%                 
%                 s = sqrt( ( vsp(i) * temp_sumX2p - ( temp_sumXp )^2 ) / (vsp(i)*(vsp(i)-1)) );
%                 bound = TINV_VALUES(vsp(i)-1) * s/sqrt(vsp(i));
%                 CIp(i,1) =  temp_sumXp/vsp(i) - bound;
%                 CIp(i,2) =  temp_sumXp/vsp(i) + bound;
%             end           
%             %real CIs
%             temp_visitnum = Number_hpe2_Action(state.hpe2, state.c, a);
%             if temp_visitnum < 2
%                 CI(i,1) = -realmax;
%                 CI(i,2) = realmax;
%             else                
%                 s = sqrt( ( temp_visitnum * SqrE2(state.hpe2, state.c, a) - ( SumE2(state.hpe2, state.c, a) )^2 ) / ( temp_visitnum*(temp_visitnum-1) ) );
%                 bound = TINV_VALUES(temp_visitnum-1) * s/sqrt(temp_visitnum);
%                 CI(i,1) =  Q_hpe2(state.hpe2, state.c, a) - bound;
%                 CI(i,2) =  Q_hpe2(state.hpe2, state.c, a) + bound;
%             end            
%             CI = double(CI);
%        % end
%         
%         % for E3
%             i=6;
%             vsp(i) = Number_hpe3_Action(state.hpe3, state.c, a) - Visit_joint(a);            
%             % CIps for performing the test
%             if vsp(i) < 2
%                 CIp(i,1) = -realmax;
%                 CIp(i,2) = realmax;
%             else
%                 temp_sumXp = SumE3(state.hpe3, state.c, a) - SumJ(state.x, state.y, state.HP, state.hpe1, a);
%                 temp_sumX2p =  SqrE3(state.hpe3, state.c, a) -  SqrJ(state.x, state.y, state.HP, state.hpe1, a);
%                 
%                 s = sqrt( ( vsp(i) * temp_sumX2p - ( temp_sumXp )^2 ) / (vsp(i)*(vsp(i)-1)) );
%                 bound = TINV_VALUES(vsp(i)-1) * s/sqrt(vsp(i));
%                 CIp(i,1) =  temp_sumXp/vsp(i) - bound;
%                 CIp(i,2) =  temp_sumXp/vsp(i) + bound;
%             end           
%             %real CIs
%             temp_visitnum = Number_hpe3_Action(state.hpe3, state.c, a);
%             if temp_visitnum < 2
%                 CI(i,1) = -realmax;
%                 CI(i,2) = realmax;
%             else                
%                 s = sqrt( ( temp_visitnum * SqrE3(state.hpe3, state.c, a) - ( SumE3(state.hpe3, state.c, a) )^2 ) / ( temp_visitnum*(temp_visitnum-1) ) );
%                 bound = TINV_VALUES(temp_visitnum-1) * s/sqrt(temp_visitnum);
%                 CI(i,1) =  Q_hpe3(state.hpe3, state.c, a) - bound;
%                 CI(i,2) =  Q_hpe3(state.hpe3, state.c, a) + bound;
%             end            
%             CI = double(CI);
%        % end
       
       
        %% perform the Generalization test base on the CIps and M
        
        %valid CIs which will be used in the decision making section
        validCI = [];
        
        for i=1:num_sensor
            if ~(M1 >= CIp(i,2) || M2 <= CIp(i,1)) 
                validCI = [validCI; [CI(i,:), i]];
                temp_OKtest(i,a) = 1;
            end
        end
        %% Decision making based on the combination of MOS and soft policy
        
        selectedSource = LUS( validCI , [M1,M2]  );

        if selectedSource == 0
            upperBound_selectedSource = M2;
        else
            upperBound_selectedSource = CI(selectedSource,2);
        end
        
        % find the master sensor in decision making
        for i=1:num_sensor
            if CI(i,2) == upperBound_selectedSource
                temp_MasterSensor(i,a) = 1;
            end
        end
        if M2 == upperBound_selectedSource
            temp_MasterSensor(num_sensor+1,a) = 1;
        end
        
%         Qtemp(a) = upperBound_selectedSource;
        
        % use the Qvalue of the selected source as the representive value for action a
        if selectedSource == 0 
            %case of the joint space
            Qtemp(a) = Q(state.x, state.y, state.HP, state.hpe1, a); % only uncomment this line to have a normal MC method
        elseif selectedSource == 1
            %case of the individual sensors
            Qtemp(a) = Q_XY(state.x, state.y, state.c, a);
        elseif selectedSource == 2
            %case of the individual sensors
            Qtemp(a) = Q_HP(state.HP, state.c, a);
        elseif selectedSource == 3
            Qtemp(a) = Q_de1(state.de1, state.c, a);
        end
        
        
    end
    
%     action = epsilonPolicy(Qtemp', agent.epsilon );
%     [charaction, numaction]=Choose_action(Policy, state, Qtemp');


     Policy.parameter = 0.1;
    % Policy.parameter = 20/(2*sum(Number_S_Action(state.x, state.y, :))); % for Boltzman
    if strcmp(Policy.type,'Boltzman')==1 && Policy.parameter < 1
        Policy.parameter = 1;
    end
    
    flag=0;
%     rowa = find(Number_S_Action(state.x, state.y, :)==0);
    
    if strcmp(Policy.type,'e-greedy')==1
        if (rand(1) <= 1-Policy.parameter)
            [~, act]=max( Qtemp(:) );  % reshape to colomn 
            flag=1;
        else
        % randomly ( Pr = epsilon/|A| ) choose one of the actions .
            act = ceil( NumAction *rand(1) );
            flag=1;
        end
    elseif strcmp(Policy.type,'Boltzman')==1
        P = reshape(exp(Qtemp(:)./Policy.parameter)./sum(exp(Qtemp(:)./Policy.parameter)),1, NumAction);
        rnd=rand(1);
        for i=1 : NumAction
            if rnd<=sum(P(1:i))
                act=i;
                flag=1;
                break;
            end
        end
    end
    
    
if act==1
    action='me1';
elseif act==2
    action='ae1';
 elseif act==3
     action='rt';
 end

         
    charaction=action;
    numaction=act;

end

