function [reward, nextState] = performAction_Stochastic(state,action,numaction)
% Perform action in the given state, return next state and reward

global  Q Q_Upper Number_S_Action Number_S2NS_Action Trns_S2NS_Action Reward_S_Action Ret NRet BestR alpha gama delta
global MaxStep num_episode num_runs LL P_C Environment fg_goal
global NumAction Clusters
global WP wp NumE 
    


    reward = 0;
    fg=0;

    bpunishment= 0;
    apunishment= -2;
    MU = [-1.5; -0.5];
    SIGMA = cat(3,[0.2],[0.3]);
    p = [1/3, 2/3];
    obj = gmdistribution(MU,SIGMA,p);
    WR = random(obj,1);
    while WR<apunishment ||  WR > bpunishment
        WR = random(obj,1);
    end
  
    agoal= 95.5;
    bgoal= 100.5;
    GR = 100 + 0.15*randn();
    while GR < agoal || GR > bgoal
        GR = 100 + 0.15*randn();
    end
    
    agoal= 18;
    bgoal= 20;
    RE = 19 + 0.1*randn();
    while RE < agoal || RE > bgoal
        RE = 19 + 0.1*randn();
    end
    RE=0;
    
    agoal= 9;
    bgoal= 11;
    RA = 10 + 0.1*randn();  % punishment for wrong attack
    while RA < agoal || RA > bgoal
        RA = 10 + 0.1*randn();
    end
    RA=-RA;
    
    [ElocX ,ElocY]= find(Environment==2); %X is row , Y is clm    
    
   
    stt=state;
%     state.x=stt.y;
%     state.y=stt.x;
    nextState = state;
    NumMove = 4;
      
%     for i=1: NumE
%         d(i, 1)=state.de1;  abs(state.x - ElocX(i)) + abs(state.y - ElocY(i));
%     end
    
        d(1, 1)=state.de1;
        
    rnd=rand;
    if rnd<= P_C(numaction)
         %% movement update by doig below
         %% Update hitPoints
             if strcmp(action , 'ae1')
                 if state.hpe1>1 && d(1, 1)<=WP
                    nextState.hpe1=state.hpe1 -1;
                    if nextState.hpe1==1
                         reward= reward + RE;
                    end
                 else
                     reward= reward + RA;
                 end
             end
             if strcmp( action, 'ae2')
                 if state.hpe2>1 && d(2, 1)<=WP
                    nextState.hpe2=state.hpe2 -1;
                    if nextState.hpe2==1
                         reward= reward + RE;
                    end
                 elseif state.hpe2==1
                     reward= reward + RA;
                 end 
             end
             if strcmp( action, 'ae3')
                  if state.hpe3>1 && d(3, 1)<=WP
                     nextState.hpe3=state.hpe3 -1;
                     if nextState.hpe3==1
                         reward= reward + RE;
                     end
                  elseif state.hpe3==1
                      reward= reward + RA;
                 end 
             end
             %% Retreat
             if strcmp(action , 'rt')
                 dnew2=d-1;
                 id = find(dnew2<= wp');
%                  while numel(id)~=0
%                      nextState.x=nextState.x +1;
                     nextState.y=nextState.y -1;
                     nextState.x=nextState.x +1;
                     dnew2= abs(nextState.x - ElocX)+ abs(nextState.y - ElocY);
                     id = find(dnew2<=wp');
%                  end
             end
             
        
         if strcmp(action , 'me1')
             if state.x==ElocX(1) && state.y <= ElocY(1)
                 nextState.y = state.y+1;
             elseif state.x==ElocX(1) && state.y >= ElocY(1)
                 nextState.y = state.y-1;
             elseif state.y==ElocY(1) && state.x <= ElocX(1)
                 nextState.x = state.x+1;
             elseif state.y==ElocY(1) && state.x >= ElocX(1)
                 nextState.x = state.x-1;
             elseif state.y<=ElocY(1) && state.x >= ElocX(1)
                 nextState.x = state.x-1;
                 nextState.y = state.y+1;
             elseif state.y>=ElocY(1) && state.x <= ElocX(1)
                 nextState.x = state.x+1;
                 nextState.y = state.y-1;
             elseif state.y >=ElocY(1) && state.x >= ElocX(1)
                 nextState.x = state.x-1;
                 nextState.y = state.y-1;
             elseif state.y<=ElocY(1) && state.x <= ElocX(1)
                 nextState.x = state.x+1;
                 nextState.y = state.y+1;
             end
         end
         
         if strcmp(action , 'me2')
             if state.x==ElocX(2) && state.y <= ElocY(2)
                 nextState.y = state.y+1;
             elseif state.x==ElocX(2) && state.y >= ElocY(2)
                 nextState.y = state.y-1;
             elseif state.y==ElocY(2) && state.x <= ElocX(2)
                 nextState.x = state.x+1;
             elseif state.y==ElocY(2) && state.x >= ElocX(2)
                 nextState.x = state.x-1;
             elseif state.y<=ElocY(2) && state.x >= ElocX(2)
                 nextState.x = state.x-1;
                 nextState.y = state.y+1;
             elseif state.y>=ElocY(2) && state.x <= ElocX(2)
                 nextState.x = state.x+1;
                 nextState.y = state.y-1;
             elseif state.y >=ElocY(2) && state.x >= ElocX(2)
                 nextState.x = state.x-1;
                 nextState.y = state.y-1;
             elseif state.y<=ElocY(2) && state.x <= ElocX(2)
                 nextState.x = state.x+1;
                 nextState.y = state.y+1;
             end
         end
         
         if strcmp(action , 'me3')
             if state.x==ElocX(3) && state.y <= ElocY(3)
                 nextState.y = state.y+1;
             elseif state.x==ElocX(3) && state.y >= ElocY(3)
                 nextState.y = state.y-1;
             elseif state.y==ElocY(3) && state.x <= ElocX(3)
                 nextState.x = state.x+1;
             elseif state.y==ElocY(3) && state.x >= ElocX(3)
                 nextState.x = state.x-1;
             elseif state.y<=ElocY(3) && state.x >= ElocX(3)
                 nextState.x = state.x-1;
                 nextState.y = state.y+1;
             elseif state.y>=ElocY(3) && state.x <= ElocX(3)
                 nextState.x = state.x+1;
                 nextState.y = state.y-1;
             elseif state.y >=ElocY(3) && state.x >= ElocX(3)
                 nextState.x = state.x-1;
                 nextState.y = state.y-1;
             elseif state.y<=ElocY(3) && state.x <= ElocX(3)
                 nextState.x = state.x+1;
                 nextState.y = state.y+1;
             end
          end
         
    else
        
       if strcmp(action , 'me1')
            mr=randi([1, 8]);
            fg=1;
        end
        
        if strcmp(action , 'me2')
            mr=randi([1, 8]);
            fg=1;
        end
        
        if strcmp(action , 'me3')
            mr=randi([1, 8]);
            fg=1;
        end
         
         if strcmp(action , 'rt')
             
         end
         
         if strcmp(action , 'ae1')
             if d(1)<=WP
                nextState.hpe1=state.hpe1;
             end
         end
         
         if strcmp(action , 'ae2')
             if d(2)<=WP
                nextState.hpe2=state.hpe2;
             end
         end
         
         if strcmp(action , 'ae3')
             if d(3)<=WP
                nextState.hpe3=state.hpe3;
             end
         end
         
    end

       if fg==1
             if mr==1
                 nextState.y = state.y+1;
             elseif mr==2
                 nextState.y = state.y-1;
             elseif mr==3
                 nextState.x = state.x+1;
             elseif mr==4
                 nextState.x = state.x-1;
             elseif mr==5
                 nextState.x = state.x-1;
                 nextState.y = state.y+1;
             elseif mr==6
                 nextState.x = state.x+1;
                 nextState.y = state.y-1;
             elseif mr==7
                 nextState.x = state.x-1;
                 nextState.y = state.y-1;
             elseif mr==8
                 nextState.x = state.x+1;
                 nextState.y = state.y+1;
             end
       end
    
        if Environment( nextState.x , nextState.y)==1
            nextState.x=state.x;
            nextState.y=state.y;
        end
     %% Enemy action
     for i=1: NumE
        dnew(i)= abs(nextState.x - ElocX(i))+ abs(nextState.y - ElocY(i));
        if dnew(i)<= wp(i) && state.HP>1
            nextState.HP= state.HP -1;
        end
     end
     
     %% Update rewards

     reward = reward + 10*( (state.hpe1 - nextState.hpe1) - (state.HP - nextState.HP)) - 1;
%       reward = reward + 2*( (state.hpe1 - nextState.hpe1) + 0 + 0 - (state.HP - nextState.HP)) - 0.1;
     
     if (nextState.hpe1==1 )
        reward= GR + 10*(nextState.HP);
     end
     
%      if (nextState.hpe1==1)
%         reward= GR;
%      end

     
     if nextState.HP==1
         reward= -GR - 10*(nextState.hpe1 );
     end
     
   
    if ((state.hpe1==1)) || (state.HP==1)
        fg_goal=1;
    end

%    stt=nextState;
%    nextState.x=stt.y;
%    nextState.y=stt.x;
   nextState.c =1; %Clusters( (Clusters(:,1)== nextState.x & Clusters(:, 2)== nextState.y) , 3);
   
    nextState.de1= (dnew(1))+1;
   
   
end

