function [rewards , steps,XP] =Q_landa(Landa ,AlphaType)
% TD(landa) Learning
% Q-Learning


global  Q Q_B Number_S_Action Number_S2NS_Action Trns_S2NS_Action Reward_S_Action Ret NRet BestR alpha gama delta E
global MaxStep num_episode num_runs numAction Length LL P_C landa Startingstate fg_goal
global NumAction SState


XP = zeros(MaxStep,4,num_episode); %  [reward,state.x,state.y,action]

landa=Landa;
rewards = zeros(1,num_episode);
steps = zeros(1,num_episode);
parameter=1;
Policy = struct('type','e-greedy','parameter',parameter); 
for ep=1 : num_episode
    
    Policy.parameter = parameter / ep;
    
    step_num = 0;
    state = SState; 
    [charaction, numaction]=Choose_action_StarC(Policy, state, Q);   % policy is based on Q_BD
    
    while (step_num <MaxStep && fg_goal==0)
  
         if AlphaType==1
            alpha = 1./(1+Number_S_Action);
        elseif AlphaType==2
            alpha = sqrt(1./(1+Number_S_Action));
        elseif AlphaType==3
            alpha = 1./(1+ sqrt(Number_S_Action));
        elseif AlphaType==4
            alpha = 1./(1+ep);
        elseif AlphaType==5
            alpha = sqrt(1./(1+ep));
        elseif AlphaType==6
            alpha = 1./(1+ sqrt(ep));
        elseif AlphaType==7
            alpha = 0.1;
        elseif AlphaType==8
            alpha = 0.9;
        elseif AlphaType==9
            alpha = 0.7;
        end
  
  
        step_num=step_num+1;
        
        [reward, nextState] = performAction_Stochastic_StarC(state,charaction, numaction);
         
        [Ncharaction, Nnumaction]=Choose_action_StarC(Policy, nextState, Q);   % policy is based on Q_BD
 
         [~, action2]=max( Q(nextState.x, nextState.y, nextState.HP, nextState.hpe1, nextState.hpe2, nextState.hpe3, :) );
         aStar=action2(1, 1);
         diff=reward + gama* Q(nextState.x, nextState.y, nextState.HP, nextState.hpe1, nextState.hpe2, nextState.hpe3, aStar) - Q(state.x ,state.y , state.HP, state.hpe1, state.hpe2, state.hpe3, numaction); 
         E(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, numaction) =  E(state.x, state.y, state.HP, state.hpe1,  state.hpe2, state.hpe3, numaction)+1;
         
         Q = Q + (alpha*diff).* E ;
         
         if aStar==Nnumaction
             E= (gama*landa).*E;
         else
             E=0.*E;
         end
         
           % Updating
         postActionUpdate_StarC(state, nextState, reward, numaction);
         
         XP(step_num,:,ep)=[reward, state.x ,state.y ,numaction];
         rewards(ep) = rewards(ep) + reward;
%           reward
         state= nextState;
         charaction=Ncharaction;
         numaction=Nnumaction;
                   
    end
    fg_goal=0;
    steps (1,ep) = step_num ;

end

end
    