function [rewards , steps, XP] =Q_landa_Ped(Landa, delta, AlphaType, AlphaTypeSub)
% TD(landa) Learning
% Q-Learning


global  Q Q_B Number_S_Action Number_S2NS_Action Trns_S2NS_Action Reward_S_Action BestR alpha gama E
global MaxStep num_episode num_runs numAction Length LL P_C landa Startingstate fg_goal
global NumAction  Q_X Q_Y gama_s TINV_VALUES Number_X_Action Number_Y_Action
global SState
global Number_HP_Action Number_HP2HP_Action Number_hpe1_Action Number_hpe12hpe1_Action Number_hpe2_Action Number_hpe22hpe2_Action Number_hpe3_Action Number_hpe32hpe3_Action
global Q_HP Q_HPU Q_HPL Q_hpe1 Q_hpe1U Q_hpe1L Q_hpe2 Q_hpe2U Q_hpe2L Q_hpe3 Q_hpe3U Q_hpe3L
global E_X E_Y E_HP E_E1 E_E2 E_E3 NumE
global Ret NRet SumJ SqrJ RetX NRetX SumX SqrX RetY NRetY SumY SqrY RetHP NRetHP SumHP SqrHP RetE1 NRetE1 SumE1 SqrE1 RetE2 NRetE2 SumE2 SqrE2 RetE3 NRetE3 SumE3 SqrE3
global Number_DE1_Action Number_D1NDE1_Action Number_DE2_Action Number_D2NDE2_Action Number_DE3_Action Number_D3NDE3_Action
global Q_de1 Q_XY E_XY Q_de2 Q_de3
global RetDE1 NRetDE1 SumDE1 SqrDE1 RetDE2 NRetDE2 SumDE2 SqrDE2 RetDE3 NRetDE3 SumDE3 SqrDE3
global RetXY NRetXY SumXY SqrXY Number_XY_Action
global E_DE1 E_DE2 E_DE3



TINV_VALUES = tinv(1-(delta/2),1:100000000);
landa=Landa;
rewards = zeros(1,num_episode);
steps = zeros(1,num_episode);
parameter=1;
Policy = struct('type','e-greedy','parameter',parameter); 
XP = zeros(MaxStep,4,num_episode);
HPS= zeros(MaxStep,NumE+1,num_episode);
DE=zeros(MaxStep,NumE,num_episode);

for ep=1 : num_episode
    
    Policy.parameter = parameter / ep;
    step_num = 0;
    state = SState; 
    [charaction, numaction]=Choose_action_Ped_StarC(Policy, state);   % policy is based on Q_BD
    
    while (step_num <MaxStep && fg_goal==0)
  
         if AlphaType==1
            alpha = 1./(1+Number_S_Action);
        elseif AlphaType==2
            alpha = sqrt(1./(1+Number_S_Action));
        elseif AlphaType==3
            alpha = 1./(1+ sqrt(Number_S_Action));
        elseif AlphaType==4
            alpha = 1./(1+ep);
        elseif AlphaType==5
            alpha = sqrt(1./(1+ep));
        elseif AlphaType==6
            alpha = 1./(1+ sqrt(ep));
        elseif AlphaType==7
            alpha = 0.1;
         end
         if AlphaTypeSub==1
            alphaXY = (1./(1+Number_XY_Action));
            alphaY = (1./(1+Number_Y_Action));
            alphaHP = (1./(1+Number_HP_Action));
            alphaE1 = (1./(1+Number_DE1_Action));
            alphaE2 = (1./(1+Number_DE2_Action));
            alphaE3 = (1./(1+Number_DE3_Action));
        elseif AlphaTypeSub==2
            alphaXY =sqrt(1./(1+Number_XY_Action));
            alphaY =sqrt(1./(1+Number_Y_Action));
            alphaHP = sqrt(1./(1+Number_HP_Action));
            alphaE1 = sqrt(1./(1+Number_DE1_Action));
            alphaE2 = sqrt(1./(1+Number_DE2_Action));
            alphaE3 = sqrt(1./(1+Number_DE3_Action));
        elseif AlphaTypeSub==3
            alphaXY = 1./(1+ sqrt(Number_XY_Action));
            alphaY = 1./(1+ sqrt(Number_Y_Action));
            alphaHP = 1./(1+ sqrt(Number_HP_Action));
            alphaE1 = 1./(1+ sqrt(Number_DE1_Action));
            alphaE2 = 1./(1+ sqrt(Number_DE2_Action));
            alphaE3 = 1./(1+ sqrt(Number_DE3_Action));
        elseif AlphaTypeSub==4
            alphaXY = 1./(1+ log10(Number_XY_Action+1));
            alphaY = 1./(1+ log10(Number_Y_Action+1));
            alphaHP = 1./(1+ log10(Number_HP_Action+1));
            alphaE1 = 1./(1+ log10(Number_DE1_Action+1));
            alphaE2 = 1./(1+ log10(Number_DE2_Action+1));
            alphaE3 = 1./(1+ log10(Number_DE3_Action+1));
        elseif AlphaTypeSub==5
            NumX=sum(Number_X_Action, 2);
            NumXVisited=find(NumX);
            NumY=sum(Number_Y_Action, 2);
            NumYVisited=find(NumY);
            alphaX = (1./(1+(Number_X_Action./(numel(NumYVisited)+1))));
            alphaY = (1./(1+(Number_Y_Action./(numel(NumXVisited)+1))));
        elseif AlphaTypeSub==6
            NumX=sum(Number_X_Action, 2);
            NumXVisited=find(NumX);
            NumY=sum(Number_Y_Action, 2);
            NumYVisited=find(NumY);
            alphaX = sqrt(1./(1+(Number_X_Action./(numel(NumYVisited)+1))));
            alphaY = sqrt(1./(1+(Number_Y_Action./(numel(NumXVisited)+1))));
        elseif AlphaTypeSub==7
            NumX=sum(Number_X_Action, 2);
            NumXVisited=find(NumX);
            NumY=sum(Number_Y_Action, 2);
            NumYVisited=find(NumY);
            alphaX = (1./(1+ sqrt(Number_X_Action./(numel(NumYVisited)+1))));
            alphaY = (1./(1+ sqrt(Number_Y_Action./(numel(NumXVisited)+1))));
        elseif AlphaTypeSub==8
            NumX=sum(Number_X_Action, 2);
            NumXVisited=find(NumX);
            NumY=sum(Number_Y_Action, 2);
            NumYVisited=find(NumY);
            alphaX = (1./(1+log10(Number_X_Action./(numel(NumYVisited)+1)+1)));
            alphaY = (1./(1+log10(Number_Y_Action./(numel(NumXVisited)+1)+1)));
        elseif AlphaTypeSub==9
            alphaX = 0.1;
            alphaY = 0.1;
        end
  
  
        step_num=step_num+1;
        
        [reward, nextState] = performAction_Stochastic_StarC(state,charaction, numaction);
        [Ncharaction, Nnumaction]=Choose_action_Ped_StarC(Policy, nextState);   % policy is based on Q_BD

         [~, action2]=max( Q(nextState.x, nextState.y, nextState.HP, nextState.hpe1, nextState.hpe2, nextState.hpe3, :) );
         aStar=action2(1, 1);
         diff=reward + gama* Q(nextState.x, nextState.y, nextState.HP, nextState.hpe1, nextState.hpe2, nextState.hpe3, aStar) - Q(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, numaction); 
         E(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, numaction) =  E(state.x ,state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, numaction)+1;
         Q = Q + (alpha*diff).* E ;
         if aStar==Nnumaction
             E= (gama*landa).*E;
         else
             E=0.*E;
         end
         
          %Q_XY
         [~, action2]=max( Q_XY(nextState.x, nextState.y, nextState.c, :) );
         aStar=action2(1, 1);
         diff=reward + gama* Q_XY(nextState.x, nextState.y, nextState.c, aStar) - Q_XY(state.x, state.y, state.c, numaction); 
         E_XY(state.x, state.y, state.c, numaction) =  E_XY(state.x ,state.y, state.c, numaction)+1;
         Q_XY = Q_XY + (alphaXY*diff).*E_XY ;
         if aStar==Nnumaction
             E_XY= (gama*landa).*E_XY;
         else
             E_XY=0.*E_XY;
         end
         
          % Q_HP(lambda)
         [~, actionY2]=max( Q_HP(nextState.HP, nextState.c,  :) );
         aStarHP=actionY2(1, 1);
         diffHP=reward + gama_s* Q_HP(nextState.HP, nextState.c, aStarHP) - Q_HP(state.HP,state.c ,numaction); 
         E_HP(state.HP , state.c, numaction) =  E_HP(state.HP ,  state.c, numaction)+1;
         Q_HP = Q_HP + (alphaHP*diffHP).* E_HP ;
         if aStarHP==Nnumaction
             E_HP= (gama_s*landa).*E_HP;
         else
             E_HP=0.*E_HP;
         end
         
          % Q_DE1(lambda)
         [~, actiond2]=max( Q_de1(nextState.de1,  nextState.c, :) );
         aStarE1=actiond2(1, 1);
         diffE1=reward + gama_s* Q_de1(nextState.de1, nextState.c, aStarE1) - Q_de1(state.de1, state.c ,numaction); 
         E_DE1(state.de1, state.c ,numaction) =  E_DE1(state.de1, state.c, numaction)+1;
         Q_de1 = Q_de1 + (alphaE1*diffE1).* E_DE1 ;
         if aStarE1==Nnumaction
             E_DE1= (gama_s*landa).*E_DE1;
         else
             E_DE1=0.*E_DE1;
         end
         
         % Q_DE2(lambda)
         [~, actiond2]=max( Q_de2(nextState.de2,  nextState.c, :) );
         aStarE1=actiond2(1, 1);
         diffE1=reward + gama_s* Q_de2(nextState.de2, nextState.c, aStarE1) - Q_de2(state.de2, state.c ,numaction); 
         E_DE2(state.de2, state.c ,numaction) =  E_DE2(state.de2, state.c, numaction)+1;
         Q_de2 = Q_de2 + (alphaE2*diffE1).* E_DE2 ;
         if aStarE1==Nnumaction
             E_DE2= (gama_s*landa).*E_DE2;
         else
             E_DE2=0.*E_DE2;
         end
         
          % Q_DE3(lambda)
         [~, actiond2]=max( Q_de3(nextState.de3,  nextState.c, :) );
         aStarE1=actiond2(1, 1);
         diffE1=reward + gama_s* Q_de3(nextState.de3, nextState.c, aStarE1) - Q_de3(state.de3, state.c ,numaction); 
         E_DE3(state.de3, state.c ,numaction) =  E_DE3(state.de3, state.c, numaction)+1;
         Q_de3 = Q_de3 + (alphaE3*diffE1).* E_DE3 ;
         if aStarE1==Nnumaction
             E_DE3= (gama_s*landa).*E_DE3;
         else
             E_DE3=0.*E_DE3;
         end
         
           % Updating
         postActionUpdate_StarC(state, nextState, reward, numaction);
         
          XP(step_num,:, ep)=[reward, state.x ,state.y ,numaction];
          HPS(step_num,:, ep)=[state.HP, state.hpe1, state.hpe2, state.hpe3];
          DE(step_num,:, ep)=[state.de1, state.de2, state.de3];
         
          rewards(ep) = rewards(ep) + reward;      
         state= nextState;
         charaction=Ncharaction;
         numaction=Nnumaction;
                   
    end
    
    fg_goal=0;
     steps (1,ep) = step_num ;

     for i=1: step_num
        % calculate the future discounted reward
        discountedReward = 0;
        ctr=0;
        for j=i : step_num
            discountedReward = discountedReward + (gama^ctr) * XP(j,1, ep);
            ctr=ctr+1;
        end
   
        Ret(XP(i, 2,ep), XP(i, 3, ep), HPS(i, 1,ep), HPS(i, 2,ep), HPS(i, 3,ep), HPS(i, 4,ep), XP(i, 4, ep)) =(( Ret(XP(i, 2,ep), XP(i, 3, ep), HPS(i, 1,ep), HPS(i, 2,ep), HPS(i, 3,ep), HPS(i, 4,ep), XP(i, 4, ep)) * NRet(XP(i, 2,ep), XP(i, 3, ep), HPS(i, 1,ep), HPS(i, 2,ep), HPS(i, 3,ep), HPS(i, 4,ep), XP(i, 4, ep)) ) + discountedReward ) / (NRet(XP(i, 2,ep), XP(i, 3, ep), HPS(i, 1,ep), HPS(i, 2,ep), HPS(i, 3,ep), HPS(i, 4,ep), XP(i, 4, ep)) + 1) ;
        NRet(XP(i, 2,ep), XP(i, 3, ep), HPS(i, 1,ep), HPS(i, 2,ep), HPS(i, 3,ep), HPS(i, 4,ep), XP(i, 4, ep))=NRet(XP(i, 2,ep), XP(i, 3, ep), HPS(i, 1,ep), HPS(i, 2,ep), HPS(i, 3,ep), HPS(i, 4,ep), XP(i, 4, ep)) + 1;
        SumJ(XP(i, 2,ep), XP(i, 3, ep), HPS(i, 1,ep), HPS(i, 2,ep), HPS(i, 3,ep), HPS(i, 4,ep), XP(i, 4, ep) ) = SumJ(XP(i, 2,ep), XP(i, 3, ep), HPS(i, 1,ep), HPS(i, 2,ep), HPS(i, 3,ep), HPS(i, 4,ep), XP(i, 4, ep) ) + discountedReward;
        SqrJ(XP(i, 2,ep), XP(i, 3, ep), HPS(i, 1,ep), HPS(i, 2,ep), HPS(i, 3,ep), HPS(i, 4,ep), XP(i, 4, ep) ) =  SqrJ(XP(i, 2,ep), XP(i, 3, ep), HPS(i, 1,ep), HPS(i, 2,ep), HPS(i, 3,ep), HPS(i, 4,ep), XP(i, 4, ep))  +  discountedReward^2 ;
%         Q(XP(i, 2), XP(i, 3), XP(i, 4)) = Ret(XP(i, 2), XP(i, 3), XP(i, 4))  ;

        RetXY(XP(i, 2,ep), XP(i, 3, ep), 1, XP(i, 4, ep)) =(( RetXY(XP(i, 2,ep), XP(i, 3, ep), 1, XP(i, 4, ep)) * NRetXY(XP(i, 2,ep), XP(i, 3, ep),1, XP(i, 4, ep)) ) + discountedReward ) / (NRetXY(XP(i, 2,ep), XP(i, 3, ep), 1, XP(i, 4, ep)) + 1) ;
        NRetXY(XP(i, 2,ep), XP(i, 3, ep), 1, XP(i, 4, ep))=NRetXY(XP(i, 2,ep), XP(i, 3, ep), 1, XP(i, 4, ep)) + 1;
        SumXY(XP(i, 2,ep), XP(i, 3, ep), 1, XP(i, 4, ep) ) = SumXY(XP(i, 2,ep), XP(i, 3, ep), 1, XP(i, 4, ep) ) + discountedReward;
        SqrXY(XP(i, 2,ep), XP(i, 3, ep), 1, XP(i, 4, ep) ) =  SqrXY(XP(i, 2,ep), XP(i, 3, ep), 1, XP(i, 4, ep))  +  discountedReward^2 ;
  
        RetHP(HPS(i, 1, ep), 1, XP(i, 4, ep)) =(( RetHP(HPS(i, 1, ep), 1, XP(i, 4, ep)) * NRetHP(HPS(i, 1, ep), 1, XP(i, 4, ep)) ) + discountedReward ) / (NRetHP(HPS(i, 1, ep), 1, XP(i, 4, ep)) + 1) ;
        NRetHP(HPS(i, 1, ep), 1, XP(i, 4, ep))=NRetHP(HPS(i, 1, ep), 1, XP(i, 4, ep)) + 1;
        SumHP(HPS(i, 1, ep), 1, XP(i, 4, ep) ) = SumHP(HPS(i, 1, ep), 1, XP(i, 4, ep)) + discountedReward;
        SqrHP(HPS(i, 1, ep), 1, XP(i, 4, ep) ) =  SqrHP(HPS(i, 1, ep), 1, XP(i, 4, ep))  +  discountedReward^2 ;
        
        RetDE1(DE(i, 1, ep), 1, XP(i, 4, ep)) =(( RetDE1(DE(i, 1, ep), 1, XP(i, 4, ep)) * NRetDE1(DE(i, 1, ep), 1, XP(i, 4, ep)) ) + discountedReward ) / (NRetDE1(DE(i, 1, ep), 1, XP(i, 4, ep)) + 1) ;
        NRetDE1(DE(i, 1, ep), 1, XP(i, 4, ep))=NRetDE1(DE(i, 1, ep), 1, XP(i, 4, ep)) + 1;
        SumDE1(DE(i, 1, ep), 1, XP(i, 4, ep) ) = SumDE1(DE(i, 1, ep), 1, XP(i, 4, ep)) + discountedReward;
        SqrDE1(DE(i, 1, ep), 1, XP(i, 4, ep) ) =  SqrDE1(DE(i, 1, ep), 1, XP(i, 4, ep))  +  discountedReward^2 ;
        
        RetDE2(DE(i, 2, ep), 1, XP(i, 4, ep)) =(( RetDE2(DE(i, 2, ep), 1, XP(i, 4, ep)) * NRetDE2(DE(i, 2, ep), 1, XP(i, 4, ep)) ) + discountedReward ) / (NRetDE2(DE(i, 2, ep), 1, XP(i, 4, ep)) + 1) ;
        NRetDE2(DE(i, 2, ep), 1, XP(i, 4, ep))=NRetDE2(DE(i, 2, ep), 1, XP(i, 4, ep)) + 1;
        SumDE2(DE(i, 2, ep), 1, XP(i, 4, ep) ) = SumDE2(DE(i, 2, ep), 1, XP(i, 4, ep)) + discountedReward;
        SqrDE2(DE(i, 2, ep), 1, XP(i, 4, ep) ) =  SqrDE2(DE(i, 2, ep), 1, XP(i, 4, ep))  +  discountedReward^2 ;
        
        RetDE3(DE(i, 3, ep), 1, XP(i, 4, ep)) =(( RetDE3(DE(i, 3, ep), 1, XP(i, 4, ep)) * NRetDE3(DE(i, 3, ep), 1, XP(i, 4, ep)) ) + discountedReward ) / (NRetDE3(DE(i, 3, ep), 1, XP(i, 4, ep)) + 1) ;
        NRetDE3(DE(i, 3, ep), 1, XP(i, 4, ep))=NRetDE3(DE(i, 3, ep), 1, XP(i, 4, ep)) + 1;
        SumDE3(DE(i, 3, ep), 1, XP(i, 4, ep) ) = SumDE3(DE(i, 3, ep), 1, XP(i, 4, ep)) + discountedReward;
        SqrDE3(DE(i, 3, ep), 1, XP(i, 4, ep) ) =  SqrDE3(DE(i, 3, ep), 1, XP(i, 4, ep))  +  discountedReward^2 ;
        
        
        
     end
       
end
 




