global WeightEGS3D aveRewardArrayS3D aveRewardArrayS aveRewardArraySMB aveRewardArraySLA


% save('Mix.mat')
[h, p, ci, INF]=ttest2(aveRewardArraySMB(:, 1:50), aveRewardArrayS(:, 1:50), 'tail', 'both', 'vartype', 'unequal', 'Alpha',0.05);
[h2, p2, ci2, INF2]=ttest2(aveRewardArrayS3D(:, 1:50), aveRewardArraySLA(:, 1:50), 'tail', 'both', 'vartype', 'unequal', 'Alpha',0.05);
% [h3, p3, ci3, INF3]=ttest2(aveRewardArrayMDP, aveRewardArrayQLZ, 'tail', 'left', 'vartype', 'unequal', 'Alpha',0.05);
V1=sqrt(var(aveRewardArrayS(:, 1:50)))./sqrt(10);
V2=sqrt(var(aveRewardArraySMB(:, 1:50)))./sqrt(10);
V3=sqrt(var(aveRewardArrayS3D(:, 1:50)))./sqrt(10);
V5=sqrt(var(aveRewardArraySLA(:, 1:50)))./sqrt(10);


ind=find(h==1);
xmarkers =ind; % place markers at these x-values
ymarkers = mean(aveRewardArraySMB(:, ind));
% plot(xmarkers,ymarkers,'r*');
% plot(mean(aveRewardArrayMB), 'b');


figure;
hold on
grid on
subplot(1, 2, 1); plot(mean(aveRewardArrayS3D(:, 1:50)),  'c ' ,'LineWidth',4)
hold on
grid on
subplot(1, 2, 1); plot(mean(aveRewardArrayS(:, 1:50)),  'r' ,'LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySMB(:, 1:50)),'b-.','LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySLA(:, 1:50)),'m-.','LineWidth',4)
set(gca, 'fontsize', 12, 'FontWeight','bold')
% subplot(1, 2, 1); plot(mean(aveRewardArraySP),  'g--' ,'LineWidth',2)
legend('MoBLeS+4IR', 'MoBLeS', 'MB', 'QL+4IR');
xlabel('#episode', 'FontSize', 16,'FontWeight', 'bold')
ylabel('Average accumulated reward', 'FontSize', 16,'FontWeight', 'bold')

% errorbar([1,10,20,30,40,50,60,70,80,90] , mean(aveRewardArrayS(:, [1,10,20,30,40,50,60,70,80,90])), INF.sd(2, [1,10,20,30,40,50,60,70,80,90] ),  '.r')
% errorbar([1,10,20,30,40,50,60,70,80,90] , mean(aveRewardArraySMB(:, [1,10,20,30,40,50,60,70,80,90])), INF.sd(1,[1,10,20,30,40,50,60,70,80,90] ) ,'.b')
% errorbar([1,10,20,30,40,50,60,70,80,90] , mean(aveRewardArraySQL( :, [1,10,20,30,40,50,60,70,80,90])), INF2.sd(1, [1,10,20,30,40,50,60,70,80,90] ),  '.k')
% errorbar([1,10,20,30,40,50,60,70,80,90] , mean(aveRewardArraySP( :, [1,10,20,30,40,50,60,70,80,90])),  INF2.sd(2, [1,10,20,30,40,50,60,70,80,90] ),  '.g')

subplot(1, 2, 1); errorbar([5,15,25,35,45] , mean(aveRewardArrayS(:, [5,15,25,35,45] )), INF.sd(2, [5,15,25,35,45] ),  '.r')
subplot(1, 2, 1); errorbar( [5,15,25,35,45] , mean(aveRewardArraySMB(:,  [5,15,25,35,45] )), INF.sd(1, [5,15,25,35,45] ) ,'.b')
subplot(1, 2, 1); errorbar( [5,15,25,35,45] , mean(aveRewardArrayS3D( :, [5,15,25,35,45] )), INF2.sd(1, [5,15,25,35,45] ),  '.c')
subplot(1, 2, 1); errorbar( [5,15,25,35,45] , mean(aveRewardArraySLA( :, [5,15,25,35,45] )), INF2.sd(2, [5,15,25,35,45] ),  '.m')
% subplot(1, 2, 1); errorbar( [5,15,25,35,45,55,65,75,85,95] , mean(aveRewardArraySP( :,  [5,15,25,35,45,55,65,75,85,95] )),  INF2.sd(2, [5,15,25,35,45,55,65,75,85,95] ),  '.g')
axis([0 50 -160 0]);

for i=1: size(WeightEGS3D, 1)
    WeightEGSN(i, :, :) = WeightEGS3D(i, :, 1:10) ./ sum(WeightEGS3D(:, :, 1:10), 1);
    WeightEGSS(i, :) = smooth(mean(WeightEGSN(i, :, :), 3), 5);
end
subplot(1, 2, 2); plot(WeightEGSS','LineWidth',2);

% subplot(1, 2, 2); plot(WeightEGSS(1,:)','b-.','LineWidth',2);
% hold on
% subplot(1, 2, 2); plot(WeightEGSS(2,:)','g--','LineWidth',2);
% subplot(1, 2, 2); plot(WeightEGSS(3,:)','r','LineWidth',2);
% legend('Subspace y', 'Subspace x', 'Joint space')
grid on
set(gca, 'fontsize', 12, 'FontWeight','bold')
xlabel('#episode', 'FontSize', 16,'FontWeight', 'bold');
ylabel('Normalized wieght of each space','FontSize', 16,'FontWeight', 'bold');
 legend('Subspace y','Subspace x','Subspace IR-up','Subspace IR-right','Subspace IR-down','Subspace IR-left','Joint space');
axis([0 50 0 1]);
   


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

figure;
hold on
grid on
subplot(1, 2, 1); plot(mean(aveRewardArrayS3D(:, 1:50)),  'c ' ,'LineWidth',4)
hold on
grid on
subplot(1, 2, 1); plot(mean(aveRewardArrayS(:, 1:50)),  'r' ,'LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySMB(:, 1:50)),'b-.','LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySLA(:, 1:50)),'m-.','LineWidth',4)




subplot(1, 2, 1);
hold on
varargout2= shadedErrorBar(1:size(aveRewardArrayS3D(:, 1:50), 2),mean(aveRewardArrayS3D(:, 1:50)), V3, 'c:', 1);
% varargout3= shadedErrorBar(1:size(aveRewardArraySP, 2),mean(aveRewardArraySP), INF2.sd(2, :), 'g--', 1);
varargout1= shadedErrorBar(1:size(aveRewardArraySMB(:, 1:50), 2),mean(aveRewardArraySMB(:, 1:50)), V2, 'b-.', 1);
varargout4= shadedErrorBar(1:size(aveRewardArrayS(:, 1:50), 2), mean(aveRewardArrayS(:, 1:50)), V1, 'r', 1);
varargout3= shadedErrorBar(1:size(aveRewardArraySLA(:, 1:50), 2),mean(aveRewardArraySLA(:, 1:50)), V5, 'm.', 1);
% varargout6= shadedErrorBar(1:size(aveRewardArrayQLZ, 2),mean(aveRewardArrayQLZ), INF3.sd(2, :), 'k:', 1);


ind=find(h==1);
xmarkers =ind; % place markers at these x-values
ymarkers = mean(aveRewardArrayS(: ,ind));

% subplot(1, 2, 1); plot(xmarkers,ymarkers,'r *', 'LineWidth',1);


subplot(1, 2, 1); plot(mean(aveRewardArrayS3D(:, 1:50)),  'c ' ,'LineWidth',4)
hold on
grid on
subplot(1, 2, 1); plot(mean(aveRewardArrayS(:, 1:50)),  'r' ,'LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySMB(:, 1:50)),'b-.','LineWidth',4)
subplot(1, 2, 1); plot(mean(aveRewardArraySLA(:, 1:50)),'m.','LineWidth',4)
set(gca, 'fontsize', 12, 'FontWeight','bold')
legend('MoBLeS+4IR', 'MoBLeS', 'MB', 'QL+4IR');
xlabel('#episode',  'FontSize', 16,'FontWeight', 'bold')
ylabel('Average accumulated reward',  'FontSize', 16,'FontWeight', 'bold')
axis([0 50 -200 0]);


% plot(xmarkers,ymarkers,'r*');


% %%%%%%%%%%%%%%%%%%%%5
% Weight
for i=1: size(WeightEGS3D, 1)
    WeightEGSN(i, :, :) = WeightEGS3D(i, :, 1:10) ./ sum(WeightEGS3D(:, :, 1:10), 1);
    WeightEGSS(i, :) = smooth(mean(WeightEGSN(i, :, :), 3), 5);
end
subplot(1, 2, 2); plot(WeightEGSS','LineWidth',4);

% subplot(1, 2, 2); plot(WeightEGSS(1,:)','b-.','LineWidth',2);
% hold on
% subplot(1, 2, 2); plot(WeightEGSS(2,:)','g--','LineWidth',2);
% subplot(1, 2, 2); plot(WeightEGSS(3,:)','r','LineWidth',2);
% legend('Subspace y', 'Subspace x', 'Joint space')
grid on
set(gca, 'fontsize', 12, 'FontWeight','bold')
xlabel('#episode',  'FontSize', 16,'FontWeight', 'bold');
ylabel('Normalized wieght of each space', 'FontSize', 16,'FontWeight', 'bold');
 legend('Subspace y','Subspace x','Subspace IR-up','Subspace IR-right','Subspace IR-down','Subspace IR-left','Joint space');
axis([0 50 0 1]);





