function [rewards , steps,XP] =Q_landa(Landa ,AlphaType)
% TD(landa) Learning
% Q-Learning


global  Q Q_B Number_S_Action Number_S2NS_Action Trns_S2NS_Action Reward_S_Action Ret NRet BestR alpha gama delta E
global MaxStep num_episode num_runs numAction Length LL P_C landa Startingstate fg_goal
global NumAction


XP = zeros(MaxStep,4,num_episode); %  [reward,state.x,state.y,action]

landa=Landa;
rewards = zeros(1,num_episode);
steps = zeros(1,num_episode);
parameter=1;
Policy = struct('type','e-greedy','parameter',parameter); 
for ep=1 : num_episode
    
    Policy.parameter = parameter / ep;
    
    step_num = 0;
    reward=0;
    % create an episode
    % first State
    state = struct('x',Startingstate.x(ep),'y',Startingstate.y(ep)); 
    [charaction, numaction]=Choose_action(Policy, state, Q);   % policy is based on Q_BD
    %[charaction, numaction] = Choose_action(epsilon, state, Q);  %Choose_action(0, state, Q_UCRL);
%     E =zeros(LL, LL, NumAction); 
    while (step_num <MaxStep && fg_goal==0)
  %  while ( reward~=BestR)
  
         if AlphaType==1
            alpha = 1./(1+Number_S_Action);
        elseif AlphaType==2
            alpha = sqrt(1./(1+Number_S_Action));
        elseif AlphaType==3
            alpha = 1./(1+ sqrt(Number_S_Action));
        elseif AlphaType==4
            alpha = 1./(1+ep);
        elseif AlphaType==5
            alpha = sqrt(1./(1+ep));
        elseif AlphaType==6
            alpha = 1./(1+ sqrt(ep));
        elseif AlphaType==7
            alpha = 0.1;
        elseif AlphaType==8
            alpha = 0.9;
        elseif AlphaType==9
            alpha = 0.7;
        end
  
  
        step_num=step_num+1;
        
        [reward, nextState] = performAction_Stochastic(state,charaction);
        [Ncharaction, Nnumaction]=Choose_action(Policy, nextState, Q);   % policy is based on Q_BD
%          [Ncharaction, Nnumaction] = Choose_action(epsilon, nextState, Q);
         
         % Q(lambda)
         [~, action2]=max( Q(nextState.x, nextState.y, :) );
         aStar=action2(1, 1);
         diff=reward + gama* Q(nextState.x, nextState.y, aStar) - Q(state.x ,state.y ,numaction); 
         E(state.x ,state.y ,numaction) =  E(state.x ,state.y ,numaction)+1;
         
         Q = Q + (alpha*diff).* E ;
         
         if aStar==Nnumaction
             E= (gama*landa).*E;
         else
             E=0.*E;
         end
         
           % Updating
         postActionUpdate(state, nextState, reward, numaction);
         
        XP(step_num,:,ep)=[reward, state.x ,state.y ,numaction];
          rewards(ep) = rewards(ep) + reward;
          
         state= nextState;
         charaction=Ncharaction;
         numaction=Nnumaction;
                   
%           fprintf('State is %d %d\n',state.x, state.y);

        

    end
    fg_goal=0;
     steps (1,ep) = step_num ;
end
     % end of episode

%      for i=1: step_num
%         % calculate the future discounted reward
%         discountedReward = 0;
%         ctr=0;
%         for j=i : step_num
%             discountedReward = discountedReward + (gama^ctr) * XP(j,1);
%             ctr=ctr+1;
%         end
% 
%         Ret(XP(i, 2), XP(i, 3), XP(i, 4)) =(( Ret(XP(i, 2), XP(i, 3), XP(i, 4)) * NRet(XP(i, 2), XP(i, 3), XP(i, 4)) ) + discountedReward ) / (NRet(XP(i, 2), XP(i, 3), XP(i, 4)) + 1) ;
%         NRet(XP(i, 2), XP(i, 3), XP(i, 4))=NRet(XP(i, 2), XP(i, 3), XP(i, 4)) + 1;
%         Q(XP(i, 2), XP(i, 3), XP(i, 4)) = Ret(XP(i, 2), XP(i, 3), XP(i, 4))  ;
%      end
%         steps (1,ep) = step_num ;
% end
