function [ mos ] = MOS( CIs , M  )
%Choose the most optimistic source among individual sensors and M
% mos: 0-joint space,  numbers-sensor numbers

    mos = 0;
    bound_up = realmax;
    if size(CIs,1)>0
        [bound_up, index] = max(CIs(:,2));
        bound_low = min(CIs(:,2));
        if bound_up == bound_low 
            index = ceil(rand*size(CIs,1));
        end
        mos = CIs(index,3);
    end
    if M(2)< bound_up
        mos = 0;
    end

    
end

