function [rewards , steps,XP] =Q_linear(alphaLType)
% TD(landa) Learning
% Q-Learning


global  QL Number_S_Action alphaL gama 
global MaxStep num_episode fg_goal
global NumAction SState
global LLx LLy LL HP
global Startingstate Teta Numsubspaces


XP = zeros(MaxStep,4,num_episode); %  [reward,state.x,state.y,action]
rewards = zeros(1,num_episode);
steps = zeros(1,num_episode);
parameter=1;
Policy = struct('type','e-greedy','parameter',parameter);
d= abs((LLx-2 -1))+abs((LLy-2 -1))+1;
SumDim=(LLx+LLy+HP+d);
Phi= zeros( (SumDim)*NumAction ,1);
Teta =  zeros( (SumDim)*NumAction ,1);

for ep=1 : num_episode
    
    Policy.parameter = parameter / ep;
    
    step_num = 0;
    state = SState; 
    [charaction, numaction]=Choose_action_StarC(Policy, state, QL);   % policy is based on Q_BD
    
    while (step_num <MaxStep && fg_goal==0)
  
         if alphaLType==1
            alphaL = 1./(Numsubspaces);
        elseif alphaLType==2
            alphaL = 1./(1+10*(Numsubspaces-1));
        elseif alphaLType==3
            alphaL = 1./(1+ep);
        elseif alphaLType==4
            alphaL = sqrt(1./(1+ep));
        elseif alphaLType==5
            alphaL = 1./(1+ sqrt(ep));
        elseif alphaLType==6
            alphaL = 0.1;
        end
  
  
        step_num=step_num+1;
        
        [reward, nextState] = performAction_Stochastic_StarC(state,charaction, numaction);
         
        [Ncharaction, Nnumaction]=Choose_action_StarC(Policy, nextState, QL);   % policy is based on Q_BD
 
         [~, action2]=max( QL(nextState.x, nextState.y, nextState.HP, nextState.hpe1, :) );
         aStar=action2(1, 1);
         diff=reward + gama* QL(nextState.x, nextState.y, nextState.HP, nextState.hpe1, aStar) - QL(state.x ,state.y , state.HP, state.hpe1, numaction); 
         
         Phi( [ ((numaction-1)*(SumDim))+state.x; ((numaction-1)*(SumDim))+(LLx+state.y); ((numaction-1)*(SumDim))+(LLx+LLy+state.HP); ((numaction-1)*(SumDim))+(LLx+LLy+HP+state.de1) ] ) = [1;1;1;1];
         Teta = Teta+ alphaL*(diff)* Phi;
         QL(state.x ,state.y , state.HP, state.hpe1, numaction ) = (Teta)' * Phi ;
         
         Phi= zeros( SumDim*NumAction ,1);
         

           % Updating
%          postActionUpdate(state, nextState, reward, numaction);
         
         XP(step_num,:,ep)=[reward, state.x ,state.y ,numaction];
         rewards(ep) = rewards(ep) + reward;
%           reward
         state= nextState;
         charaction=Ncharaction;
         numaction=Nnumaction;
                   
    end
    fg_goal=0;
    steps (1,ep) = step_num ;

end

end
    