#include "mex.h"
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "matrix.h"


void mexFunction(int nlhs, mxArray *plhs[], int nrhs, mxArray *prhs[])
{
/* Macros for the ouput and input arguments */
// #define B_OUT plhs[0]
#define BXY_OUT plhs[0]
   
#define Trns_X2NX_Action prhs[0]
    
#define Reward_X_Action prhs[1]
 
#define Q2X prhs[2]

#define epsilon prhs[3]
#define gama prhs[4]
#define gamax prhs[5]
#define gamay prhs[6]
#define epi prhs[7]
#define Environment prhs[8]   
#define Delta prhs[9] 
#define NumC prhs[10]
#define LLS prhs[11]

       
    
size_t KX = mxGetNumberOfDimensions(Q2X);
const mwSize *NX = mxGetDimensions(Q2X);
double *QX = mxGetPr(Q2X);

int W=0;
double NC = mxGetScalar(NumC);
double LL2S = mxGetScalar(LLS);

size_t K_TX = mxGetNumberOfDimensions(Trns_X2NX_Action);
const mwSize *N_TX = mxGetDimensions(Trns_X2NX_Action);
double *PX = mxGetPr(Trns_X2NX_Action);
double *RX = mxGetPr(Reward_X_Action);

double *Env = mxGetPr(Environment);
double eps = mxGetScalar(epsilon);
double ga = mxGetScalar(gama);
double ep = mxGetScalar(epi);
double gax = mxGetScalar(gamax);
double gay = mxGetScalar(gamay);
double delta = mxGetScalar(Delta);

float inlog = ep+9;
float L = log10(inlog);
float teta=0.01/L;
double *B, *BX, *BY, *BI, *BIr, *BId,*BIl, *BXY, *BXI, *BYI;
float d1=0;
float d2=0;
float d3=0;
int act;
int i;
int j;
int actt;
double q,  Rewardx, qxu, MMDX;
double MMD;
int ii;
int jj;
 double sumQ;
double maxQ;
double tempQ;
int is, js, Indtemp;
double QN;
int iy, iiy;
int ix,iix, actx, acttx;
double  sumQX, maxQX;
int itemp, jtemp, h1, h11, h2, h22, h3, h33, Hp, He, He2, He3;
int h4, h44, ic,iic;
double *X2, *Y2, *HP, *HE, *HE2, *HE3;
mxArray *X2Array, *Y2Array, *NHPArray, *NHEArray, *NHEArray2, *NHEArray3;


mxArray *PTempAray, *PTempArayX, *PTempArayY;

double *U, *U2, *SU;
double *UX, *SUX; 
int *SInX, *SInY, *SIn, *Ind;
double *UY, *SUY, *PTemp, *PTempX, *PTempY;
double TmpC, CI_r, CI_p, r, Reward, SumP, SumPP;
int ctr, ctrp, ctr2, flag;
mxArray *UAray, *UAray2;
mxArray *UArayX;
mxArray *UArayY;
mxArray *IndArray;
double QNX;


UArayX = mxCreateDoubleMatrix( (N_TX[2]*N_TX[3]*N_TX[5]) , 1, mxREAL);
UX = mxGetPr(UArayX); 
PTempArayX = mxCreateDoubleMatrix( (N_TX[2]*N_TX[3]*N_TX[5]) , 1, mxREAL);
PTempX = mxGetPr(PTempArayX); 

// B_OUT = mxCreateNumericArray(K, N, mxDOUBLE_CLASS, mxREAL);
// B = mxGetPr(B_OUT);

BXY_OUT = mxCreateNumericArray(KX, NX, mxDOUBLE_CLASS, mxREAL);
BX = mxGetPr(BXY_OUT);
 

// mexPrintf("teta=%f", teta);
X2Array = mxCreateDoubleMatrix( LL2S , 1, mxREAL);
X2 = mxGetPr(X2Array); 
Y2Array = mxCreateDoubleMatrix( LL2S , 1, mxREAL);
Y2 = mxGetPr(Y2Array); 

////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
while(true)
{
    d2=0;
    for (ix=1; ix< (N_TX[0]-1); ix++)
    {
        X2[0]=ix-1;
        X2[1]=ix;
        X2[2]=ix+1;
        
        for (iy=1; iy< (N_TX[1]-1); iy++)
        {
            Y2[0]=iy-1;
            Y2[1]=iy;
            Y2[2]=iy+1;
                
           for (ic=0; ic<N_TX[4]; ic++)
          {
            for (actx=0; actx<N_TX[6]; actx++)
            { 
                qxu=QX[ix + (N_TX[0] * ( iy + (N_TX[1]* (ic + (N_TX[4] * actx)))))] ;
                MMDX=0;

              for ( iix=0; iix<N_TX[2]; iix++)
              {
                for (iiy=0; iiy<N_TX[3]; iiy++) 
                {
                   for ( iic=0; iic<NC; iic++ )
                   {    
                       itemp= X2[iix];
                       jtemp= Y2[iiy];
                        sumQX=0;
                        maxQX=-10000000000;
                       for ( acttx=0; acttx<N_TX[6]; acttx++)
                       {
                           sumQX=sumQX+QX[itemp + (N_TX[0] * ( jtemp + (N_TX[1]* (ic + (N_TX[4] * actx)))))] ;
                           if (maxQX < QX[itemp + (N_TX[0] * ( jtemp + (N_TX[1]* (ic + (N_TX[4] * actx)))))] )
                           {
                                maxQX= QX[itemp + (N_TX[0] * ( jtemp + (N_TX[1]* (ic + (N_TX[4] * actx)))))] ;
                           }
                       }
                        
                        
                  QNX = ((1-eps)* maxQX) ;
                  MMDX=MMDX+( PX[ix+ (N_TX[0]*( iy + (N_TX[1] * (iix+  (N_TX[2]* ( iiy + (N_TX[3] * (ic + (N_TX[4]* (iic + (N_TX[5] * actx))))))))))) ] *( RX[ix+ (N_TX[0]*( iy + (N_TX[1] * (iix+  (N_TX[2]* ( iiy + (N_TX[3] * (ic + (N_TX[4]* (iic + (N_TX[5] * actx))))))))))) ] + (gax*QNX)) );
                    }
                }
               }              
                QX[ix + (N_TX[0] * ( iy + (N_TX[1]* (ic + (N_TX[4] * actx)))))]  = MMDX ;
                BX[ix + (N_TX[0] * ( iy + (N_TX[1]* (ic + (N_TX[4] * actx)))))] = MMDX ;

                maxQ= fabs(qxu- QX[ix + (N_TX[0] * ( iy + (N_TX[1]* (ic + (N_TX[4] * actx)))))] );
                if (d2>maxQ)
                    maxQ=d2;
                d2=maxQ;

    //             mexPrintf("************** d2=%f  ,  QX=%f , CI_r=%f *********** \n", d2, QXU[ix + (N_TX[0]*(actx))], CI_r);

            }
           }
        }
    }

    if (d2<teta)
        break;
}




return;
}