function [charaction, numaction, WP, W]= Choose_action_subspace2_IR3 ( Policy, state, Thr) 
% New function for choose action in subspace
% this is the normal version


global  Q Q_B Number_S_Action Number_S2NS_Action Trns_S2NS_Action Reward_S_Action Ret NRet BestR alpha gama delta E Q_BD Q_X Q_Y
global MaxStep num_episode num_runs NumAction Length LL P_C landa
global Q_LCRL Q_XL Q_YL
global Array_CI_p M_Array m_Array D_Array ChooseSpace
global Q_UCRL Q_XU Q_YU
global Number_X_Action Number_X2NX_Action Trns_X2NX_Action Number_Y_Action Number_Y2NY_Action Trns_Y2NY_Action Reward_X_Action Reward_Y_Action
global Numsubspaces Q_XY Q_XI Q_YI Q_I
global NumIR Q_XYU Q_XYL Q_XIU Q_XIL Q_YIU Q_YIL Q_IU Q_IL CountW
global Q_Ir Q_IrU Q_IrL Q_Id Q_IdU Q_IdL Q_Il Q_IlU Q_IlL
global Q_HP Q_HPU Q_HPL Q_hpe1 Q_hpe1U Q_hpe1L Q_hpe2 Q_hpe2U Q_hpe2L Q_hpe3 Q_hpe3U Q_hpe3L
global Q_de1 Q_de1U Q_de1L Q_de2 Q_de2U Q_de2L Q_de3 Q_de3U Q_de3L

% SState = struct('x',10,'y',3, 'HP', HP,  'hpe1', HPE(1),  'hpe2', HPE(2),  'hpe3', HPE(3), 'c', 1); 

Policy.parameter = 0.1;

flag=0;

% assign probability
P = zeros(Numsubspaces,NumAction); % 1 for x ---- 2 for y ---- 3 for joint

if strcmp(Policy.type,'e-greedy')==1
    P(:, :) = Policy.parameter/NumAction ;
    [~, axy]=max(Q_XY(state.x, state.y, state.c, :));
    [~, ae1]=max(Q_de1(state.de1, state.c, :));
    [~, ae2]=max(Q_de2(state.de2, state.c, :));
    [~, ae3]=max(Q_de3(state.de3, state.c, :));
    [~, ahp]=max(Q_HP(state.HP,  state.c, :));
    [~, aj]=max(Q_BD(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, :));
    
    P(1, axy)=P(1, axy)+ 1-Policy.parameter ;
    P(2, ae1)=P(2, ae1)+ 1-Policy.parameter ;
    P(3, ae2)=P(3, ae2)+ 1-Policy.parameter ;
    P(4, ae3)=P(4, ae3)+ 1-Policy.parameter ;
    P(5, ahp)=P(5, ahp)+ 1-Policy.parameter ;
    P(6, aj)=P(6, aj)+ 1-Policy.parameter ;

elseif strcmp(Policy.type,'Boltzman')==1
    % this if not be used
    for i=1 : NumAction
        P(1, :)= reshape(exp(QX(state.x, :)./Policy.parameter)./sum(exp(QX(state.x, :)./Policy.parameter)),1, NumAction);
        P(2, :)= reshape(exp(QY(state.y, :)./Policy.parameter)./sum(exp(QY(state.y, :)./Policy.parameter)),1, NumAction);
        P(3, :)= reshape(exp(Q2(state.x, state.y, :)./Policy.parameter)./sum(exp(Q2(state.x, state.y, :)./Policy.parameter)),1, NumAction);
    end
end


% assign weight
W = zeros(Numsubspaces,NumAction); % 1 for x ---- 2 for y ---- 3 for joint

Dif_XY= Q_XYU - Q_XYL;
Dif_HP= Q_HPU - Q_HPL;
Dif_d1= Q_de1U - Q_de1L;
Dif_d2= Q_de2U - Q_de2L;
Dif_d3= Q_de3U - Q_de3L;
Dif_J= abs(Q_UCRL - Q_LCRL);


intersecXY=0;
intersecHP=0;
intersecde1=0;
intersecde2=0;
intersecde3=0;
     
for i=1 : NumAction

     JU=Q_UCRL(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3,  i);
    JL= Q_LCRL(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3,  i);

    intersecXY = IntersectionF(JU,JL, Q_XYU(state.x, state.y, state.c, i), Q_XYL(state.x, state.y, state.c, i));
    intersecHP = IntersectionF(JU,JL, Q_HPU(state.HP, state.c, i), Q_HPL(state.HP, state.c, i));
%     intersechpe1 = IntersectionF(JU,JL, Q_hpe1U(state.hpe1, state.c, i), Q_hpe1L(state.hpe1, state.c, i));
%     intersechpe2 = IntersectionF(JU,JL, Q_hpe2U(state.hpe2, state.c, i), Q_hpe2L(state.hpe2, state.c, i));
%     intersechpe3 = IntersectionF(JU,JL, Q_hpe3U(state.hpe3, state.c, i), Q_hpe3L(state.hpe3, state.c, i));
    intersecd1 = IntersectionF(JU,JL, Q_de1U(state.de1, state.c, i), Q_de1L(state.de1, state.c, i));
    intersecd2 = IntersectionF(JU,JL, Q_de2U(state.de2, state.c, i), Q_de2L(state.de2, state.c, i));
    intersecd3 = IntersectionF(JU,JL, Q_de3U(state.de3, state.c, i), Q_de3L(state.de3, state.c, i));
    
    
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
  
    xy1 =  ( Dif_J(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i)) / Dif_XY(state.x, state.y, state.c, i)  ; 
    d11 =  ( Dif_J(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i)) / Dif_d1(state.de1, state.c, i)  ;
    d21 =  ( Dif_J(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i)) / Dif_d2(state.de2, state.c, i)  ;
    d31 =  ( Dif_J(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i)) / Dif_d3(state.de3, state.c, i)  ;
     HP1 =  ( Dif_J(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i)) / Dif_HP(state.HP, state.c, i)  ;
     

     %%%%%%%%%%%%%% IR %%%%%%%%%
     a=2;
     b=2;
     
     if Number_S_Action( state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i)> 0%> 0 %>-1 %> 1  
          xy2= abs(Q_BD(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i)- Q_XY(state.x, state.y, state.c, i)) /intersecXY ;
          if b*xy2>1
             xy2=1/b;
         end
         xy6 = -erfinv(b*xy2 - 1);
          if xy6>=10
             xy6=10;
         elseif xy6<1
             xy6=0;
          end
          
         HP2= abs(Q_BD(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i)- Q_HP(state.HP, state.c, i)) /intersecHP ;
          if b*HP2>1
             HP2=1/b;
         end
         HP6 = -erfinv(b*HP2 - 1);
          if HP6>=10
             HP6=10;
         elseif HP6<1
             HP6=0;
          end
         
%           hpe12= abs(Q_BD(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i)- Q_hpe1(state.hpe1, state.c, i)) /intersechpe1 ;
%           if b*hpe12>1
%              hpe12=1/b;
%          end
%          hpe16 = -erfinv(b*hpe12 - 1);
%           if hpe16>=10
%              hpe16=10;
%          elseif hpe16<1
%              hpe16=0;
%           end
%          
%           hpe22= abs(Q_BD(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i)- Q_hpe2(state.hpe2, state.c, i)) /intersechpe2 ;
%           if b*hpe22>1
%              hpe22=1/b;
%          end
%          hpe26 = -erfinv(b*hpe22 - 1);
%           if hpe26>=10
%              hpe26=10;
%          elseif hpe26<1
%              hpe26=0;
%          end
%          
%           hpe32= abs(Q_BD(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i)- Q_hpe3(state.hpe3, state.c, i)) /intersechpe3 ;
%           if b*hpe32>1
%              hpe32=1/b;
%          end
%          hpe36 = -erfinv(b*hpe32 - 1);
%          if hpe36>=10
%              hpe36=10;
%          elseif hpe36<1
%              hpe36=0;
%          end
         
         d12= abs(Q_BD(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i)- Q_de1(state.de1, state.c, i)) /intersecd1 ;
          if b*d12>1
             d12=1/b;
         end
         d16 = -erfinv(b*d12 - 1);
         if d16>=10
             d16=10;
         elseif d16<1
             d16=0;
         end
         
         d22= abs(Q_BD(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i)- Q_de2(state.de2, state.c, i)) /intersecd2;
          if b*d22>1
             d22=1/b;
         end
         d26 = -erfinv(b*d22 - 1);
         if d26>=10
             d26=10;
         elseif d26<1
             d26=0;
         end
         
         d32= abs(Q_BD(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i)- Q_de3(state.de3, state.c, i)) /intersecd3;
          if b*d32>1
             d32=1/b;
         end
         d36 = -erfinv(b*d32 - 1);
         if d36>=10
             d36=10;
         elseif d36<1
             d36=0;
         end
         
     else 
         HP6=10.2;
         hpe16=10.2;
         hpe26=10.2;
         hpe36=10.2;
         d16=10.2;
         d26=10.2;
         d36=10.2;
         xy6=10.2;
     end
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%    
     
      W(1, i)= xy1 * xy6 ;
      W(2, i)= d11 * d16;
      W(3, i)= d21 * d26;
      W(4, i)= d31 * d36;
      W(5, i)= HP1 * HP6;
%       W(4, i)= hpe11 * hpe16;
%       W(5, i)= hpe21 * hpe26;
%       W(6, i)= hpe31 * hpe36;
      

         if Dif_J(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i) / Dif_XY(state.y, state.y, state.c, i) < 0.9
             W(1, i)=0;
         end
       if Dif_J(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i) / Dif_d1(state.de1, state.c, i)  < 0.9
         W(2, i)=0;
      end
      if Dif_J(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i) / Dif_d2(state.de2, state.c, i)  < 0.9
         W(3, i)=0;
      end
      if Dif_J(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i) / Dif_d3(state.de3, state.c, i)  < 0.9
         W(4, i)=0;
      end
      if Dif_J(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i) / Dif_HP(state.HP, state.c, i)  < 0.9
         W(5, i)=0;
      end
     
%       if Dif_J(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i) / Dif_hpe1(state.hpe1, state.c, i)  < 0.9
%          W(4, i)=0;
%       end
%       if Dif_J(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i) / Dif_hpe2(state.hpe2, state.c, i)  < 0.9
%          W(5, i)=0;
%       end
%       if Dif_J(state.x, state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, i) / Dif_hpe3(state.hpe3, state.c, i)  < 0.9
%          W(6, i)=0;
%       end
        
     W(Numsubspaces, i)= 1 ;
     
      maxW=1;
      indW=Numsubspaces;
      for j=1:Numsubspaces-1
          if (W(j, i)>= maxW && CountW(j) <= Thr)
              maxW = W(j, i);
              indW = j;
          end
          W(j, i) =0;
      end
     W(Numsubspaces,i) =0;
     W(indW, i)=1;

end


WP= W .* P;
Prob = sum (WP(:,:), 1);
Prob = Prob./sum(Prob);

% % flag=0;
% -- find best action acccording probability
if flag==0 || 1
    rnd=rand(1);
    for i=1 : NumAction
        if rnd<=sum(Prob(1:i))
            act=i;
            flag=1;
            %fprintf('%d\n', sum(Prob(1:i)));
            break;
        end
    end
% -- find just max probability
%     [~, act]=max(Prob);
end




     if act==1
        action='me1';
    elseif act==2
        action='me2';
    elseif act==3
        action='me3';
    elseif act==4
        action='ae1';
     elseif act==5
         action='ae2';
     elseif act==6
         action='ae3';
     elseif act==7
         action='rt';
    elseif act==8
        action='rto';
     end
 

    charaction=action;
    numaction=act;
end




