function [rewards , steps, XP] =Q_Bellman()

% Bellman learning

global  Q Q_B Number_S_Action Number_S2NS_Action Trns_S2NS_Action Reward_S_Action Ret NRet BestR alpha gama delta E Q_BD
global MaxStep num_episode num_runs numAction Length LL P_C landa Startingstate fg_goal
global NumAction Environment LL2J SState
global Number_HP_Action Number_HP2HP_Action Number_hpe1_Action Number_hpe12hpe1_Action Number_hpe2_Action Number_hpe22hpe2_Action Number_hpe3_Action Number_hpe32hpe3_Action
global MAXReward_S_Action MAXReward_X_Action MAXReward_Y_Action MAXReward_HP_Action MAXReward_e1_Action MAXReward_e2_Action MAXReward_e3_Action
global MINReward_S_Action MINReward_X_Action MINReward_Y_Action MINReward_HP_Action MINReward_e1_Action MINReward_e2_Action MINReward_e3_Action 
global CountWX CountWY Clusters CountW
global NumC ep 
global NHP NHPE
global NumE HP HPE LLx LLy LL2S

rewards = zeros(1,num_episode);
steps = zeros(1,num_episode);
XP = zeros(MaxStep,4,num_episode);
parameter=1;
Policy = struct('type','e-greedy','parameter',parameter); 

for ep=1 : num_episode
    
    Policy.parameter = parameter / ep;
    step_num = 0;
    state = SState;    %state = struct('x',Startingstate.x(ep),'y',Startingstate.y(ep)); 
        
    while (step_num <MaxStep && fg_goal==0)

        step_num=step_num+1;
        [charaction, numaction]=Choose_action_StarC(Policy, state, Q_BD);   % policy is based on Q_BD
        [reward, nextState] = performAction_Stochastic_StarC(state,charaction, numaction);
        postActionUpdate_StarC(state, nextState, reward, numaction);
        
        X=[state.x-1, state.x, state.x+1];
        Y=[state.y-1, state.y, state.y+1];
        Nhp = [state.HP, state.HP-1];
        Nhe1 = [state.hpe1, state.hpe1-1];
        Nhe2 = [state.hpe2, state.hpe2-1];
        Nhe3 = [state.hpe3, state.hpe3-1];
        if state.HP==1
            Nhp = [state.HP, state.HP];
        end
        if state.hpe1==1
            Nhe1 = [state.hpe1, state.hpe1];
        end
        if state.hpe2==1
            Nhe2 = [state.hpe2, state.hpe2];
        end
        if state.hpe3==1
            Nhe3 = [state.hpe3, state.hpe3];
        end
        
            
          Trns=reshape(Trns_S2NS_Action(state.x ,state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, :, :, :, :, :, :, numaction), size(Trns_S2NS_Action, 7), size(Trns_S2NS_Action, 8), size(Trns_S2NS_Action, 9), size(Trns_S2NS_Action, 10), size(Trns_S2NS_Action, 11), size(Trns_S2NS_Action, 12));
          QN=reshape(max(Q_BD(X, Y, Nhp, Nhe1, Nhe2, Nhe3, :), [], 7), numel(X), numel(Y), numel(Nhp), numel(Nhe1), numel(Nhe2), numel(Nhe3));
          RN=reshape(Reward_S_Action(state.x ,state.y, state.HP, state.hpe1, state.hpe2, state.hpe3, :, :, :, :, :, :, numaction), size(Reward_S_Action, 7), size(Reward_S_Action, 8), size(Reward_S_Action, 9), size(Reward_S_Action, 10), size(Reward_S_Action, 11), size(Reward_S_Action, 12)); 
          MM= sum(sum(sum(sum(sum(sum(Trns.* (RN + gama*QN))))))) ;
          Q_BD(state.x ,state.y , state.HP, state.hpe1, state.hpe2, state.hpe3, numaction) = MM;

          
          
          
          XP(step_num,:, ep)=[reward, state.x ,state.y ,numaction];
          rewards(ep) = rewards(ep) + reward;
          state= nextState; 

    end

     fg_goal=0;
     steps (1,ep) = step_num ;
     [Q_BD]=VI_StarC(Trns_S2NS_Action, Reward_S_Action, Q_BD, 0 ,gama , ep, Environment, LL2J, NHP, NHPE);   % 1 shows number of clusters
     
     if (mod(ep,10)==0)
         ep
     end
    
end

end